 {~ Ecliptical length and width --> RA and declination ~}

program Ecl2Equ; {by J.Hollan}
uses solar_ut, str_num, params;
const
h1=cl+
'Equ2Ecl {<ecl.longitude/1degree>|<hh:mm:ss.hs>} {<e.latitude/1degree>|dd:mm:"" }'+cl2+

'transforms ecliptical J2000 coordinates into J2000 equatorial coordinates.'+cl2;
h2=
'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'+cl;

var RA,Decl:real; j:integer; hh,mi,ss,hs:word;

 procedure Help;
  begin
   write(h1,h2);
   halt
  end;
begin
val(paramstr(1),RA,j);
 if j>0 then
  if BabS2Dec(paramstr(1),hh,mi,ss,hs,RA,'H') then
   RA:=RA*15
  else help;
val(paramstr(2),Decl,j);
if j>0 then
 if not BabS2Dec(paramstr(2),hh,mi,ss,hs,Decl,'D') then help;
lb_rd(ra,decl,ra,decl);
writeln(RA:8:4,Decl:9:4,' are the J2000 right ascension and declination / 1 degree')
end.
