 {~  RA and declination --> galactic longitude and latitude ~}

program Equ2Gal; {by J.Hollan}

{192.86  27.13  are J2000 RA and Declination of the galactic pole

 266.34 -28.94  are J2000 RA and Declination of the galactic centrum

 some 33 degrees is the galactic longitude of the intersection
   of galactic equator and celestial equator
}

uses solar_ut, angles_o, str_num;
const
h1=cl+
'Equ2Gal { <RA/1degree>|<hh:mm:ss.hs> } { <Decl/1degree>|dd:mm:"" }'+cl+cl+

'transforms equatorial J2000 coordinates into galactic coordinates.'+cl2;
h2=
'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'+cl;

var RA,Decl:real; j:integer; hh,mi,ss,hs:word;

 procedure Help;
  begin
   write(h1,h2);
   halt
  end;

begin
val(paramstr(1),RA,j);
if j>0 then
 if BabS2Dec(paramstr(1),hh,mi,ss,hs,RA,'H') then
  RA:=RA*15
 else help;
val(paramstr(2),Decl,j);
if j>0 then
 if not BabS2Dec(paramstr(2),hh,mi,ss,hs,Decl,'D') then help;
RA:=deg_to_rad(RA+270-192.86);
Decl:=deg_to_rad(Decl);
ra_d2l_b(deg_to_rad(90-27.13),RA,Decl);
RA:=bas_int(rad_to_deg(RA)+33,360);
Decl:=rad_to_deg(Decl);
writeln(RA:8:2,Decl:9:2,'  are the galactic longitude and latitude / 1 degree')
end.
