 {~ Information on a star from the General Catalog of Var_first_name Stars (GCVS) ~}

  { Has to be converted to the appropriate code page;
   the original one is 'Kamenicky'
  -- this is just because of a character denoting a degree}

program f_gcvs;  {by J.Hollan}

uses gcvs ,DbBridge,params,str_num;

const
h1=cl+
'         Programme F_GCVS displays information on a chosen star'+cl+
'               from the dBase file with a small version of the'+cl+
'                 General Catalogue of Var Stars'+cl;
h15=
'Usage:' +cl;
h2=
'F_GCVS <star> <constellation> [<directory with the data>]'+cl2;

h3=
'Examples:'+cl+
'F_GCVS u Her      (it may return UUU instead of u, in old-style GCVS notation)'+cl+
'f_gcvs Miu_1 Sco  (_ means space; components are given as the fifth character'+cl+
'           - see Desi_Un.txt, a list of non-Argelander designations)'+cl+
'F_GCVS R Lyr'+cl;
h4=
'F_GCVS AB Cas'    +cl+
'F_GCVS CE__B Cas  (CE Cas has variable components A and B)'+cl+
'F_GCVS V1068 Cyg' +cl2;

h4a=
'Case of the letters is irrelevant'+cl+
' with exception of one-letter star designations  r to z / R to Z: '+cl+
' --- then the case is vital for distinguishing    Bayer / Argelander symbols'+cl+
' (using upppercase only, u Her can be coded as UUU HER, if you like).'+cl2;

h5=
'The last parameter is the directory with GCVSred.dbf and G_Con_U.txt.'+cl+
'If it is different from'+cl+
Loc_GCVS_const+','+cl+
' write a batch file with the contents'+cl;
h5a=
'    F_GCVS %1 %2 <your directory with the data>'+cl;
h6=
'Another possibility is to change the string Loc_GCVS in GCVS.pas'+cl+
'and translate f_gcvs.pas once more together with gcvs.pas:'+cl+
'    tpc /m f_gcvs'+cl2;
h7=
'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'+cl;

var
 Var_first_name : string;
 Constellation: string;
 NoR: word;
 RA, Decl : real;
 j,i: byte;

procedure help;
begin
 write(h1,h15,h2,h3,h4,h4);
 c_o_halt;
 write(h5,h5a,h6,h7);
 halt;
end;

begin

if paramcount<2 then help;
Constellation:=paramstr(2);
Var_first_name:=paramstr(1);
if paramcount>2 then Loc_GCVS:=Paramstr(3);
writeln;
if get_gcvs(Var_first_name,Constellation,RA,Decl,NoR) then
 begin
  writeln('Star Const.  RA/1  Decl/1');
  writeln(Var_first_name,' ',Constellation,'  ',RA:7:3,' ',Decl:7:3);
  writeln;
  DbDisp(NoR);
  DbClose;
  writeln;
  writeln(
'(See the file GCVSred_.txt for the explanation of the structure of data.)');
 end
else begin writeln; writeln('write  F_GCVS ?   for getting help') end

end.
