 {~ Frequency diagram from data of a special format, in Czech, by Leos Ondra ~}

Program FourierM; {by Leos Ondra, in Czech}
{$N+}{$E+}
{tisk na rovnou na CS212-25 lze vyvolat odpovedi p,
 do souboru                                      f#
 - doplnil po T.R. J.H.}

uses g_scree,Crt, Graph;

function dejjm(vstup: string): string;
   begin
   dejjm := copy(vstup,1,(pos('.',vstup))-1);
   end;

function dejpr(vstup: string): string;
   var pom : integer;
   begin
   pom := length(vstup);
   dejpr := copy(vstup,pos('.',vstup),pom);
   end;

function fix(vstup:real; f: integer):string;
   var pom : string;
   begin
   str(vstup:2:3,pom);
   fix := copy(pom,1,(pos('.',pom))+f);
   end;

function fix0(vstup:real):string;
   var pom : string;
   begin
   str(vstup:2:3,pom);
   fix0 := copy(pom,1,(pos('.',pom))-1);
   end;

label
  1, 2;

var
 pmin, pmax, str, hour, date, dp, fr, x, sumf2x, sumcx, sumsx, sumcsx : real;
 sumc2x, sums2x, sumfsx, sumfcx, cx, sx, a1, a2, m, c1, c2, smax, rp : real;
 v, w, pp, da, r, q, splot, pplot, dplot, magx, magn: real;
 oldate, pmx, jmx, jmn, s95, dt, per, epocha : real;
 ge, ha, alfa, pravd, pokus : extended;
 i, j, k, n, Gd, Gm : integer;
 inp, inp2, out1, out2, out3 : text;
 mo, y, h, d, mi, g, f, my, mx : word;
 mag, jd : array[1..1000] of real;
 ch,zn : string;

Procedure PrintScrWanted;
var NumPic : byte; resp: string[3];
begin
 readln(resp);
 if (resp[1]='f') or (resp[1]='F') then
  begin
   val(copy(resp,2,length(resp)-1),NumPic,j);
   if J=0 then PriGScrF(dejjm(paramstr(1)),NumPic);
  end
 else if (resp[1]='p') or (resp[1]='P') then
        PriGScrC
end;

{procedure tiskni;
begin
    outtextxy(100,getmaxy-20,'printer or file? (p-f)');
    ch:=readkey;
    bar(90,getmaxy-20,350,getmaxy-2);
    bar(getmaxx-80,10,getmaxx-2,50);
     if (ch='p') or (ch='P') then
       begin
        if prigscrC then
       end
       else
       begin
        prigscrf('trmouse',1);
       end;
end;}

begin  {of the MAIN PROGRAMME}
FileMode:=0; {will open the files by reset as Read Only
               -- they can be then marked so even if not on a CD;
               here it enables to have *.bgi and *.chr read-only}
 if (paramstr(1) = '') or
  (pos('?',paramstr(1))>0) or (paramstr(1)='--help') then
   begin
   writeln('Fourier - verze 1.4 (22. rijna 1993)');
   writeln('Autor Leos Ondra');
   writeln;
   writeln('Priklad pouziti:  C:\OS\LEOS>  fourier.exe betalyr.dat');
   writeln('Vstupni  soubor  betalyr.dat  obsahuje na kazdem radku');
   writeln('postupne  datum  (mezi rokem  1901  a  1999), cas (UT)');
   writeln('a hvezdnou velikost  (ci odhadni stupen). Tyto polozky');
   writeln('jsou oddelene jednou nebo vice mezerami. Jejich format');
   writeln('ukazuje priklad:');
   writeln;
   writeln('900812  23.56  12.67');
   writeln;
   writeln('znamena odhad z 12. srpna 1990 (23 h 56 min UT), pricemz');
   writeln('hvezda mela 12,67 magnitudy');
   writeln;
   writeln('Zmackni ENTER ...');
   readln; halt(1);
   end;

 assign(inp,paramstr(1));
 writeln('Fourier - verze 1.4 (22. rijna 1993)');
 writeln('Autor Leos Ondra');
 writeln; writeln;
 assign(out1, dejjm(paramstr(1))+'.jud');
 assign(out2, dejjm(paramstr(1))+'.ven');
 assign(out3, dejjm(paramstr(1))+'.max');
 write('Minimalni perioda (ve dnech):   '); readln(pmin);
 write('Maximalni perioda (ve dnech):   '); readln(pmax);
 write('Pocet intervalu:                '); readln(k);
 writeln;

 if dejpr(paramstr(1)) <> '.jud' then
begin
   assign(out1, dejjm(paramstr(1))+'.jud');
   writeln('Pocitam julianska data ...');
   reset(inp); rewrite(out1); magx := 0; magn := 0;
   i := 0; str := 0; oldate := 0;
   while not eof(inp) do
     begin
       inc(i);
       readln(inp, date, hour, mag[i]);
       if date < oldate then writeln('Poznamka: Data nejsou usporadana chronologicky');
       oldate := date;
       str := str + mag[i];
       date := date/100;
       d := trunc(frac(date)*100+0.1);
        if d > 31 then
           begin
           writeln('Spatny format dat na radku ',i);
           halt(1);
           end;
       date := int(date)/100;
       mo := trunc(frac(date)*100+0.1);
        if mo > 12 then
           begin
           writeln('Spatny format dat na radku ',i);
           halt(1);
           end;
       y := trunc(date) + 1900;
       h := trunc(hour);
       if h > 24 then
          begin
           writeln('Spatny format dat na radku ',i);
           halt(1);
          end;
       mi := trunc(frac(hour)*100);
       if mi > 59 then
          begin
          writeln('Spatny format dat na radku ',i);
          halt(1);
          end;
       da := d + (mi/60 + h)/24;
       if mo > 2 then begin
                      g := y;
                      f := mo + 1;
                     end
                else
                     begin
                      g := y - 1;
                      f := mo + 13;
                     end;
      jd[i] := int(365.25*g) + int(30.6*f) + da - 679018.5;
      writeln(out1, fix(jd[i],4),'   ', fix(mag[i],3));
      end;
      close(inp); close(out1);
      writeln('Soubor '+dejjm(paramstr(1))+'.jud vytvoren');
end
else
   begin
   i := 0; str := 0; magx := 0; magn := 0;
   reset(inp);
   while not eof(inp) do
     begin
      inc(i);
      readln(inp,jd[i], mag[i]);
      str := str + mag[i];
     end;
   close(inp);
   end;


   n := i; dt := jd[n]-jd[1];
   if pmax > dt then
     begin
     writeln;
     writeln('Poznamka: Maximalni perioda prevysuje interval mezi');
     writeln('prvnim a poslednim odhadem ('+fix(dt,2)+') dne.');
     writeln;
     end;

   str := str/n; sumf2x := 0;
   writeln;
   writeln('Pocitam frekvencni spektrum ...');

   for i := 1 to n do begin
                       mag[i] := mag[i] - str;
                       if mag[i] < magn then magn := mag[i];
                       if mag[i] > magx then magx := mag[i];
                       sumf2x := sumf2x + mag[i]*mag[i];
                      end;

1: rewrite(out2);
   dp := (pmax - pmin)/k;
   smax := 0;

   for j := 1 to k+1 do
   begin
     r := pmin + (j-1)*dp;
     fr := 1/r;
     sumcx := 0; sumsx := 0; sumc2x := 0; sums2x := 0;
     sumfcx := 0; sumfsx := 0; sumcsx := 0;
     for i := 1 to n do
       begin
         x := 2*pi*fr*(jd[i]-jd[1]);
         cx := cos(x); sx := sin(x);
         sumc2x := sumc2x + cx*cx;
         sumcx := sumcx + cx;
         sums2x := sums2x + sx*sx;
         sumsx := sumsx + sx;
         sumcsx := sumcsx + sx*cx;
         sumfcx := sumfcx + mag[i]*cx;
         sumfsx := sumfsx + mag[i]*sx;
       end;

     a1 := sqrt(1/(sumc2x - sumcx*sumcx/n));
     m := sumcsx - sumsx*sumcx/n;
     a2 := sqrt(1/(sums2x - sumsx*sumsx/n - a1*a1*m*m));
     c1 := a1*sumfcx;
     c2 := a2*(sumfsx-a1*c1*m);
     q := (c1*c1 + c2*c2)/sumf2x;
     if q > smax then
        begin
        smax := q; pmx := r;
        end;
     writeln(out2, r,'  ',q);
   end;
   close(out2);

   alfa := 2*(n-3)*(jd[n]-jd[1])*(1/pmin-1/pmax)/3/(n-4);
   ha := -ln(1-exp(1/alfa*ln(0.95)));
   ha := ha*(n-3)/(n-4) + 1;
   ge := ha; j := 10;
   for i := 1 to j do ge := ha - exp(-ge);
   s95 := 1 - exp(ge*2/(3-n));

   Sound(880); Delay(80); NoSound; Delay(30);
   Sound(880); Delay(80); NoSound; Delay(30);
   Sound(880); Delay(80); NoSound;

   assign(inp2,dejjm(paramstr(1))+'.ven');
   reset(inp2);

   Gd := Detect;
   InitGraph(Gd, Gm,'c:\s\tp\bgi');
   ClearDevice; mx := GetMaxX; my := GetMaxY;
   SetColor(14); SetBkColor(0);
   Line(30, 20, 30, my-20);
   Line(30, 20, mx-20, 20);
   Line(30, my-20, mx-20, my-20);
   Line(mx-20, 20, mx-20, my-20);
   SetColor(2);
   OutTextXY(30, 5, 'Perioda: '+fix(pmx+0.00005,4));
   OutTextXY(mx-160, 5, 'Zmackni ENTER ...');   {63}
   w := (mx-60)/(pmax-pmin);
   v := (my-50)/smax;
   if s95 < smax then
     begin
      SetColor(7);
      Line(30, my-25-trunc(s95*v), mx-20, my-25-trunc(s95*v));
      SetColor(2);
      OutTextXY(mx-50, my-43-trunc(s95*v), '95');
     end
     else
     begin
      SetColor(2);
      Line(45, 30, 40, 45);
      Line(40, 45, 50, 45);
      Line(50, 45, 45, 30);
     end;
   SetColor(14);
   for j := 1 to k+1 do
     begin
      readln(inp2,r,q);
      PutPixel(trunc((r-pmin)*w+35), my-25-trunc(q*v), 15);
     end;

   pplot := 0; pp := pmax-pmin;
   if pp > 200 then dplot := 50;
   if (pp > 100) and (pp <= 200) then
     dplot := 20;
   if (pp > 50) and (pp <= 100) then
     dplot := 10;
   if (pp > 25) and (pp <= 50) then
     dplot := 5;
   if (pp > 10) and (pp <= 25) then
     dplot := 2;
   if (pp > 5) and (pp <= 10) then
     dplot := 1;
   if (pp > 2.5) and (pp <= 5) then
     dplot := 0.5;
   if (pp > 1) and (pp <= 2.5) then
     dplot := 0.2;
   if (pp > 0.5) and (pp <= 1) then
     dplot := 0.1;
   if (pp > 0.25) and (pp <= 0.5) then
     dplot := 0.05;
   if (pp > 0.1) and (pp <= 0.25) then
     dplot := 0.02;
   if pp <= 0.1 then
     dplot := 0.01;
   repeat
    if pplot >= pmin then
       begin
        Line(trunc((pplot-pmin)*w+35), my-20, trunc((pplot-pmin)*w+35), my-17);
        if pp > 5 then
          OutTextXY(trunc((pplot-pmin)*w+32), my-10, fix0(pplot));
        if (pp > 0.5) and (pp <= 5) then
          OutTextXY(trunc((pplot-pmin)*w+30), my-10, fix(pplot,1));
        if pp <= 0.5 then
          OutTextXY(trunc((pplot-pmin)*w+28), my-10, fix(pplot,2));
       end;
    pplot := pplot + dplot;
   until pplot > pmax;

   splot := 0;
   repeat
    Line(30, my-25-trunc(splot*v), 27, my-25-trunc(splot*v));
    OutTextXY(0, my-28-trunc(splot*v), fix(splot,1));
    splot := splot + 0.1;
   until splot >= smax;
{   readln;
   tiskni;}
   PrintScrWanted;
   CloseGraph;
   write('Prejete si prepocitat pro jine periody (a/n)?  ');
   readln(zn);
   if zn = 'a' then
   begin
     write('Minimalni perioda (ve dnech):   ');readln(pmin);
     write('Maximalni perioda (ve dnech):   ');readln(pmax);
    if pmax > dt then
     begin
     writeln;
     writeln('Poznamka: Maximalni perioda prevysuje interval mezi');
     writeln('prvnim a poslednim odhadem ('+fix(dt,2)+') dne.');
     writeln;
     end;
     write('Pocet intervalu:                ');readln(k);
     writeln;
     writeln('Pocitam frekvencni spektrum ...');
     goto 1;
   end;

   writeln;
   write('Prejete si data seskladat do jedne periody (a/n)?  '); readln(zn);
2: if zn = 'a' then
    begin
      write('Perioda (nalezene maximum: '+fix(pmx+0.00005,7)+' dne):  ');
      readln(per);
      write('Zakladni epocha (prvni odhad: '+fix(jd[1]+0.00005,4)+'):  ');
      readln(epocha);

      InitGraph(Gd, Gm,'c:\s\tp\bgi');
      SetColor(14); SetBkColor(0);
      Line(30, 20, 30, my-20);
      Line(30, 20, mx-20, 20);
      Line(30, my-20, mx-20, my-20);
      Line(mx-20, 20, mx-20, my-20);
      w := (mx-60)/1.5;
      v := (my-80)/(magx-magn);
      Line(35, my-20, 35, my-15);
      Line(trunc(0.5*w+35), my-20, trunc(0.5*w+35), my-15);
      Line(trunc(w+35), my-20, trunc(w+35), my-15);
      Line(trunc(1.5*w+35), my-20, trunc(1.5*w+35), my-15);
      OutTextXY(30, 5, 'Epocha: '+fix(epocha+0.00005,4));
      OutTextXY(mx-145, 5, 'Perioda: '+fix(per+0.00005,4));

     SetColor(2);
     for i := 1 to n do
     begin
      r := frac((jd[i]-epocha)/per);
      q := mag[i];

      if (trunc(r*w+35) >= 32) and (trunc(r*w+35) <= mx-22) then
      Circle(trunc(r*w+35), trunc((q-magn)*v+40), 2);
      if (trunc(r*w+35+w) >= 32) and (trunc(r*w+35+w) <= mx-22) then
      Circle(trunc(r*w+35+w), trunc((q-magn)*v+40), 2);
     end;
{     readln;}
     PrintScrWanted;
     CloseGraph;
    end
    else
    halt(1);
     write('Seskladat pro jinou periodu (a/n)?  '); readln(zn);
     if zn = 'a' then goto 2;
end.


