 {~ Meridians and parallels for a rotational ellipsoid, like Jupiter ~} 

program grid; {by J.Hollan}
uses graph_m8,angles_o;

const
 cl=#13#10;
h1=
'Grid T# R# Ro# P# S M W[{T|P}<Output file name>]'      +cl+
'  plots a coordinate grid - default for Jupiter with tilt of 1 degree.'+cl+
'Possible parameters are:'         +cl+
'T  tilt in degrees (default 1)'   +cl+
'R  radius (default 0.9 half-height of the screen)'      +cl;
h2=
'Ro rotate (0 degrees)'            +cl+
'P  polar deficit denominator (default for Jupiter is 16.35)' +cl+
'S Saturn value of the P (=10.44)' +cl+
'M Moon (infinite) value of P'     +cl+
'W  default name is Jup_net.tex, WT default is screen.ltx,'+cl+
'WP (PostScript) default name is screen.eps'+cl+cl;
h3=
'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'+cl;

 tilt:real=1;
 shorten:real=0.9388;
 Radius:real=0.9;
 Ro:real=0;
var
 i,j:shortint;
 cy,AuxReal:real;
 y,CenX,CenY,Radiuse,Wrong_pos:integer;
 Par:string;
 Switch:char;
 V:V3;M,Ml:M3;

procedure help(message:string);
begin
 writeln(message+cl);
 write(h1,h2,h3);
 halt
end;

begin
FileMode:=0; {will open the files by reset as Read Only
               -- they can be then marked so even if not on a CD;
               here it enables to have *.bgi and *.chr read-only}
GM_Mode:=0;

if paramcount > 0 then  for i:=1 to paramcount do
  begin
   Par:=paramstr(i);
   if (Par[1]='/') or (Par[1]='-') then Par:=copy(Par,2,length(par)-1);
   Switch:=UpCase(Par[1]);
   case Switch of
    'S': Shorten:=0.9042; {Saturn}
    'M': Shorten:=1; {Sphere, like Moon}
    '?','-': Help(''); {- added to respect unix --help even without the help}
    else
     begin
      Par:=copy(Par,2,length(Par)-1);
      val(Par,AuxReal,wrong_pos);
      case Switch of
     'T': tilt:=AuxReal;
     'P':begin
          if AuxReal<=1 then
            help('The polar deficit denominator should be surely over ');
          Shorten:=1-1/AuxReal;
         end;
     'R':if UpCase(Par[1])='O'then       {rotate}
           begin
            Par:=copy(Par,2,length(Par)-1);
            val(Par,Ro,wrong_pos)
           end
         else
          Radius:= AuxReal;
      'W':begin
           if par<>'' then
            begin
             case UpCase(par[1]) of
              'T': GM_Mode:=2;
              'P': GM_Mode:=3;
             end;
             if length(par)>1 then GM_OuFile:=copy(par,2,length(par)-1);
            end
           else
            begin
             GM_OuFile:='jup_net.tex';
             GM_Mode:=2
            end;
          end
      end
     end
   end
  end; {of for}

gm_init(round(radius/0.9*75),round(radius/0.9*100));
CenX:=MaxX div 2; CenY:=MaxY div 2;
RadiusE:=round(CenY*0.9);
Mat(M,2,tilt*pi/180);

if Ro<>0 then 
 begin
  Mat(Ml,1,Ro*pi/180);
  MatL_Mat(Ml,M);
 end;

for i:=-17 to 18 do
 for j:=-45 to 45 do
  begin
   P3s_Vector(i*pi/18,j*pi/90,V);
   v[3]:=v[3]*shorten;
   Mat_Vect(M,V);
   if V[1]>0 then
    gm_circle_full(round(CenX+radiusE*V[2]),round(CenY+radiusE*V[3]),11);
  end;
for i:=-89 to 90 do
 for j:=-8 to 9 do
  begin
   P3s_Vector(i*pi/90,j*pi/18,V);
   v[3]:=v[3]*shorten;
   Mat_Vect(M,V);
   if V[1]>0 then
    gm_circle_full(round(CenX+radiusE*V[2]),round(CenY+radiusE*V[3]),11);
  end;

repeat gm_quit until false;

end.
