 {~ Plots a star chart (from the Guide Star Catalog as packed in MegaStar) ~}

program map_mgsc;  {Jan Hollan, March 1998}
(*  Copyright (C) 1999 Jan Hollan

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)

uses crt, dos, graph,
   {and J.H.'s units:}
  graph_m8, g_scree, Precesse, gcvs, Binaries, DbBridge,
  str_num,
  Un_Str_M {instead of Unit_Str by Blaise Computing, Inc.},
  map_mg_p,{faintness transformation and sorting stars for PostScript files}
  params_g, angles_o, solar_ut, planets, elm;

const
 Loc_GSC_const =
  'C:\megastar\gsc;D:\megastar\gsc;E:\megastar\gsc;'+
  'F:\megastar\gsc;G:\megastar\gsc;H:\megastar\gsc;/usr/local/megastar/gsc';
 Loc_GSC : string[130] = Loc_GSC_const;    {however, 67 is DirStr length}
 Loc_GSC_loc : string[12] ='megastar/gsc';

 rem_char=['&','%','#'];

WFile :boolean=False; {no output file}
Size_in_Dec :real=1;  {side of the field in degrees}
Small_size_in_dec:real=100; {side of small field in main map}
Faintness_Lim :byte=155;  {limit set to 155 dmag}
MinX :word=0;        {begin 0 per cent from the left margin}
Rot_Angle:real=0;    {angle to rotate the image - just for Kind>0}
Mirror :boolean=false;       {Not mirror reversed}
Kind:byte=0;   {0: rectangular, 1: Lambert, 2: gnomonic}
mode:byte=1;   {HardCopy mode 1 for CS212-25, 9 for 72 DpI, 24 for 60 DpI}
pix1:byte=16;
pix2:byte=32;
pix3:byte=48;
pix4:byte=48;
 par_file_Name:Pathstr='';
 Coord_known:boolean=false;
 RA_known:boolean=false;
 Decl_known:boolean=false;
 next_par:byte=1;
 wrtcolour:byte=60;
 help_string:string[80]='';
 NewMJD:boolean=false;

h1= cl2+
'Map_mGSC <RA> <Decl.> [e# s# f{l|b|d}# m b# w[#]<output file> k# t# tr# p# n[#]'+cl+
 '  X# Gr#'+cl+
 '  @<file with these parameters> $@<orb.elements file> $<one_element>'+cl;
h1a=
 '  LM<MegaStar directories> (default'+cl+
 '     '+loc_gsc_const+' ;'+cl+
 '     megastar\gsc is appended if you give a directory ending at \ or /)'+cl;
h2=
'  - a star chart from the GSC MegaStar catalogue.'+cl2+

'Its parameters are:  '   +cl2+

'equatorial coordinates - in degrees  or as <hh:mm:ss.cc> and <deg:'':"">'+cl;
h2a=
'    (they can be given labeled as well, as RA# and De#)'+cl+
'E#  equinox (epoch) of the given coordinates  (default 2000)'+cl;
h3=
'S#  height of the field (degrees, default 1 degree)'+cl+
'FL# faintness limit / 1 dmag (default 155) '+cl+
'FB# base of the faintness scale / 1 dmag (default = 60)'+cl+
'FD# maximum faintness for writing the faintess (default = FB)'+cl;
h4=
'M   plots mirror-reversed - RA growing to the right'+cl+
'B#  starts at # per cent from the left side of the screen'+cl+
'W   writes the stars into a text file.'+cl+
'W#  makes a picture 1:HPGL (not working), 2:LaTeX, 3:PostScript'+cl;
h5=
'K#  0 rectangular grid (default), 1 equidistant, 2 gnomonic'+cl+
'R#  rotate # degrees clockwise (just for K>0)'+cl+
'Tr# multiple faintness by (default 1)'+cl+
'X#  plot a rectangle around center, # degrees high'+cl;
h55=
'XS# side along X coordinate / 1 % of the screen (default 100)'+cl+
'YS#       (the same for Y coordinate)'+cl;
h6=
'N[#] do not show more than # parameters (default 0, when present)'+cl+
'Gr# 2:Use just black and white for stars (instead of degrees of gray)'+cl+
'    5 to 100: % of the maximum white (default 60) for lines and texts' +cl2;
h7=
'P#  9 or 24 needle printer for hardcopy (now default = 1 : CS212 printer);'+cl+
' Ctrl+Prin Screen or P makes then a hardcopy to "prn", any <Number> to a file'+cl+
' named Map_mgsc.{prn|e9|e24} - the file is either changed, or created'+cl;
h8=
' in a directory given by the TEMP environment variable. The screen is copied'+cl+
' to that file as a picture No.<Number>. Then the whole file may be copied'+cl+
' to printer Copy /b <name> prn.'+cl+cl;
h9=
'Instead of       <RA> <Decl.>,      you may give'+cl+
' <variable star name> <Const. short>     or'+cl;
h10=
'                   DB <ADS binary star number>'+cl+
' (provided the corresponding catalogues are available in the needed form).'+cl2;

h11=
'@   file with any default parameters (other than further @); default suffix'+cl+
'    is .cnf'+cl+
'$   prefix for elements concering comets etc. ($? to see help)'+cl+
'$@  file with orbital elements; defalut suffix is .elm'+cl2;
h11a=
' (the usual parameters concerning time - D, T, UT and TT'+cl+
'  may be given without $ as well, for the first time)'+cl2;
h12=
'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'+cl;



var s_strip:array [1..2048,0..3] of byte;
    s : array [0..3] of byte;
    i: word;
    NoStars : array[0..63] of word;
    Offset : array[0..63] of longint;
    RA_strip_start: array[0..63] of byte;
    N_of_belt, Rel_N_of_field,k,Max_Param,i_cfg,j_cfg:byte;
    sig:shortint;
    code,j:integer;
 Scale, ScaleR, RA_beg, Dec_eq_side, RA_Centre, Dec_Centre,
 RA_width, RA_unit,
 RA_point, Dec_point, RA_min, RA_max, RA_Scale,
 Year, Aux_r
       : real;
    dir_num, field_num: string[4];
    aux_s: string;
    dir_lett,ch : char;
    inp:file;
    out:text;
    Around0,File_found: boolean;
    j_min, j_max, j_max_orig : integer;
    NoR: word;
 FoundName:PathStr;
 zl,RA_C,RA,Decl : real;
 par_file:text;
 par_line,command_line:string;
 remark,remark_cfg:boolean;
 ParOrg:string;
 Ve:V3;
 Mat_aux:M3;

const {of MegaStar version of the GSC}
 field_count : array[0..11] of byte = (48,47,45,43,40,36,32,27,21,15,9,3);
               {numbers of files in each declination belt}
 Belt_height = 7.5;              {each belt is 7.5 degrees high in declnation}
 Dec_unit = Belt_height/(16*1024); {angular unit of declination difference in degrees}
YS:byte=100;   {per cent of the screen vertical side}
XS:byte=100;


procedure help(message:string);
var ch:char;
begin
 highvideo;
 if message<>'' then
  begin
   writeln(cl,message,cl);
   lowvideo;
   write(h0);
   ch:=readkey;
   if UpCase(ch)= 'Q' then halt;
   write(h0clear);
   highvideo;
  end;
 write(h1);
 lowvideo;
 write(h1a,'  ',h_dir_elem,'  ',h_dir_gcvs,h0);
 ch:=readkey;
 if UpCase(ch)= 'Q' then halt else write(#13);
 write(h0clear,h2,h2a,h3,h0);
 ch:=readkey;
 if UpCase(ch)= 'Q' then halt else write(#13);
 write(h0clear,h4,h5,h55,h6,h_svga1,h_svga2,h0);
 ch:=readkey;
 if UpCase(ch)= 'Q' then halt else write(#13);
 write(h0clear,h7,h8,h0);
 ch:=readkey;
 if UpCase(ch)= 'Q' then halt else write(#13);
 write(h0clear,h9,h10,h11,h11a,h12);
 halt
end;

procedure help_file;
var h_file:text;
begin
 if rt_rewrite(h_file,'Map_mGSC.hlp') then
  begin
   write(h_file,h1,h1a,'  ',h_dir_elem,'  ',h_dir_gcvs,
       h2,h2a,h3,h4,
       h5,h55,h6,h_svga1,h_svga2,h7,h8,
       h9,h10,h11,h11a,h12);
   close(h_file);
   halt;
  end
   else help('');
 halt
end;


Function To_0_360(angle:real):real;
begin
while angle>=360 do angle:=angle-360;
while angle<0 do angle:=angle+360;
To_0_360:=angle
end;



Function RA_count_inc : byte;
begin    {increment of RA is given by the left 5 bites of the third byte}
  RA_count_inc:= s[2] shr 3 ;
end;

Function Dec_count : word;
begin    {Decl. difference from the equatorial side of the field}
  Dec_count:= (s[1] shl 6) + (s[0] shr 2);
end;

Function Plate : byte;
begin
 Plate:= s[2] - ((s[2] shr 3) shl 3)
end;

Function Star_class : byte;
begin
 Star_class:= s[0] - ((s[0] shr 2) shl 2)
end;



procedure description;
var
 aux_str: string [6]; j:integer; H,X: word;

 procedure Desc_angle(Angle:real);
 begin
  str(Angle:6:2,aux_str);
  if GM_mode<1 then
   gm_circle_empty(MaxX-2*pix3,H,pix2)
  else
   gm_circle_empty(MaxX-2*pix3,H-pix2,pix1);
  {the degrees symbol has been positioned this way}
  gm_outxy(MaxX-pix2-2*pix4,H,aux_str,'r',0); inc(H,TextH+pix3);
 end;

begin
H:=TextH;

gm_comm(cl+'% Center, size and faintness limit:');
gm_outxy(RigX+pix4,H,'R.A.:','l',0); inc(H,TextH);
Desc_angle(RA_centre);

gm_outxy(RigX+pix4,H,'Decl.:','l',0); inc(H,TextH);
Desc_angle(Dec_centre);

gm_outxy(RigX+pix4,H,'v.side:','l',0);    inc(H,TextH);
Desc_angle(Size_in_Dec);

gm_line(RigX,H,MaxX,H);             inc(H,TextH+pix1);

str(Faintness_lim:3,aux_str);
gm_outxy(RigX+pix4,H,'limit:','l',0);    inc(H,TextH);
gm_outxy(MaxX-pix2,H,aux_str,'r',0);  inc(H,TextH);
gm_outxy(MaxX-pix2,H,'dmag','r',0);   inc(H,TextH+2*pix4);

gm_comm(cl+'% Faintness scale:');
X:=RigX +pix2+ ((MaxX-RigX) div 3);
for j:= 1 to 10 do
 begin
  gm_star(X,H,VT(Faintness_base+j*10),V2R(Faintness_base+j*10),0,false,'');
  str(Faintness_base+j*10,aux_str);
  gm_outxy(MaxX-pix2,H,aux_str,'r',0);
  inc(H,19 shl 4)
 end;

gm_line(RigX,H,MaxX,H);             inc(H,TextH+pix1);

gm_comm(cl+'% Parameters given to the programme:');
for j:=1 to paramcount do
 begin
  gm_outxy(RigX+pix3,H,ParamStr(j),'l',0);
  inc(H,TextH);
 end;
end;

 function MapCoord (RA,Decl:real; var X,Y:longint):boolean;
 var AR,zR,r:real;
 begin
  MapCoord:=false;

  if Kind=0 then {rectangular, no distortion on central parallel}
   begin
    X := round(CenX + (RA_C-RA)*RA_Scale);
    Y := round(CenY + (Dec_Centre-Decl)*Scale)
   end
  else {polar}
   begin
    if abs(Decl-Dec_Centre)>Size_in_Dec then
     begin
      MapCoord:=false;
      exit
     end;
    AR:=deg_to_rad(RA_C-RA);
    zR:=deg_to_rad(Decl);
    P3s_Vector(-AR,zR,Ve); {V[3] to max F, V[1] to 0 AR}
    mat_vect(Ma_Ah_to_td,Ve);
             {vector:= matrix * vector}
    r:=sqrt(sqr(Ve[1])+sqr(Ve[2]));
    if Kind=2 then
     zR:=r/Ve[3]
    else
     zR:=C2_to_Pf(Ve[3],r);
    if r=0 then
     r:=0
    else
     r:=zR * ScaleR / r;
    X:=round(CenX - r * Ve[2]);
    Y:=round(CenY + r * Ve[1])
   end;

  if X<MinX then exit;
  if (X<RigX) and (Y>-1) and (Y<MaxY) then MapCoord:=true;

 end;

Procedure PlotMap;
{just within MinX to RigX - rightmost pixels are reserved for description}
var
 RA_strip : real;
 R:word; j:byte;
 RA_count : longint;
 XRA, YDec : longint;

 function Place_star:boolean;
 begin
  RA:=RA_strip + RA_count * RA_unit;
  Decl:=sig*(Dec_eq_side + Dec_count * Dec_unit);
  Place_Star:=MapCoord(RA,Decl,XRA,YDec);
 end;

begin
if not File_found then exit;
if (RA_beg>239) and (RA_Centre<120) then RA_C:=RA_centre+360
                                   else RA_C:=RA_centre;
if (RA_beg<119) and (RA_Centre>239) then RA_C:=RA_centre-360;
for j:=j_min to j_max do
 begin
  if keypressed then
   begin
    ch:=readkey;
    if ch=#0 then ch:=readkey;
    if ch in [#27,'q','Q','3'] then
     begin
      gm_close;
      if WFile then  close(out);
      halt;
     end
   end;
  RA_strip:= RA_beg + RA_width * j / 64;
  RA_count:=-RA_strip_start[j];
  seek(inp,Offset[j] div 4);
  blockread(inp,s_strip,NoStars[j]);
  for i:= 1 to NoStars[j] do
   begin
    for k:=0 to 3 do s[k]:=s_strip[i,k];
    inc(RA_count,RA_count_inc);
    if s[3]<=Faintness_Lim then
      begin
       if Place_Star {RA_Count,Dec_count -> XRA,YDEC} then
         begin
           if Mirror then XRA:=CenX+CenX-XRA;
           if WFile then
            writeln(out,RA:9:5,Decl:9:5,s[3]:4,Plate:2,Star_class:2);
           if GM_mode<3 then
            begin
             {if Gray16_stars then
              begin  }
               r:=V2R(s[3]);
               gm_star(XRA,YDec,VT(s[3]),r,0,false,'');
             { end
             else
              gm_star(XRA,YDec,VT(s[3]),0,0,false,'');
             }
             if s[3]<=Faintness_desc then
               begin  {faintness in dmag right from the star}
                {if not Gray16_stars then r:=V2R(s[3]);}
                str(s[3],Faintness_str);
                if XRA+ r + 4*pix4 +TextWidth(Faintness_str) < RigX
                 then
                  gm_outxtxy(XRA,YDEC,'',Faintness_str,'','l',0, r+pix3,0)
                else
                  gm_outxtxy(XRA,YDEC,'',Faintness_str,'','r',0,-r-pix3,0);
               end
            end
           else
            process_ps_star(XRA,YDec,s[3]);
          end;
      end;
   end;
 end;
close(inp);
end;

procedure OpenFile(RA,De:real);
begin
N_of_belt:=(trunc(2*abs(De))) div 15;
case N_of_belt of
  0 : dir_num:='0000';
  1 : dir_num:='0730';
  12: begin dir_num:='8230'; N_of_belt:=11; end;
  else if odd(N_of_belt) then str((750*N_of_belt)-20:4,dir_num)
                 else str((750*N_of_belt):4,dir_num);
end;
if De<0 then begin dir_lett:='s'; sig:=-1 end
                else begin dir_lett:='n'; sig:=1 end;
               {Sig is +1 for northern and -1 for southern belts}

RA_width:=360/field_count[N_of_belt];
Rel_N_of_field:=trunc(RA / RA_width);
if sig=1 then str(N_of_belt*100+Rel_N_of_field:4,field_num)
         else str(((N_of_belt+12)*100+Rel_N_of_field):4,field_num);
if (Rel_N_of_field<10) and (N_of_belt=0) and (sig=1) then
           field_num:='000'+copy(field_num,4,1);
if (Rel_N_of_field>=10) and (N_of_belt=0) and (sig=1) then
           field_num:='00'+copy(field_num,3,2) ;
if field_num[1]=' ' then field_num:='0'+copy(field_num,2,3);

                        {/ works even with tp and DOS, \ fails in linux}
aux_s:=dir_lett+dir_num+'/'+field_num+'.gsc';
FoundName:=FSearch(aux_s,'');
if FoundName='' then
 FoundName:=FSearch(aux_s,Loc_GSC);
if FoundName<>'' then
  begin
   assign(inp,foundname);
   reset(inp,4);
   File_Found:=true;
  end
 else
  begin
   File_found:=false;
   exit
  end;
for i:= 0 to 63 do
 begin           {reading starts of the 64 meridional strips}
  Blockread(inp,s,1);
  Offset[i]:=s[2]*256+s[1];  {in two lines, to have Longint }
  Offset[i]:=Offset[i]*256+s[0];             { here on the right side }
  Blockread(inp,s,1);
  RA_strip_start[i]:=s[0];
 end;
for i:=0 to 62 do         {Number of stars in the segment}
 NoStars[i]:=(Offset[i+1]-Offset[i]) div 4 ;
NoStars[63]:=(4*FileSize(inp)-Offset[63]) div 4 ;

Dec_eq_side:=Belt_height*N_of_belt;  {declination of the side nearer to the equator}
RA_unit:=Dec_unit*(RA_width / Belt_height);
RA_beg:=RA_width * Rel_N_of_field ;         {minimum right ascension}

if Around0 then   {RA=0 inside the map}
 if RA_beg>180 then
   begin
    j_min:=trunc((RA_min - RA_beg) / (RA_width /64));
    j_max:=63
   end
  else
   begin
    j_max:=trunc((RA_max - RA_beg)/ (RA_width /64)) +1;
    j_min:=0;
   end

else      {RA zero not inside the map}
 begin
  j_min:=trunc((RA_min - RA_beg) / (RA_width /64));
  j_max:=trunc((RA_max - RA_beg)/ (RA_width /64)) +1;
 end;

if j_min>63 then j_min:=63; if j_min<0 then j_min:=0;
if j_max<0 then j_max:=0; if j_max>63 then j_max:=63;

end;

procedure One_File;
begin
    OpenFile(RA_Point,Dec_Point);
    PlotMap;
end;

procedure SidesOfBelt;
var N_Of_Fields:byte;
begin
 RA_Point:=RA_centre;
 N_of_Fields:=1;
 while (j_min=0) and (N_of_Fields<field_count[N_of_Belt]) do
                                {to the right from the centre file}
 begin
  inc(N_of_Fields);
  RA_point:=To_0_360(RA_point - RA_width);
  One_File;
  {if not File_found then exit}
 end;

 j_max:=j_max_orig;
 RA_Point:=RA_centre;
 while (j_max=63) and (N_of_Fields<field_count[N_of_Belt]) do
                                {to the left from the centre file}
 begin
  inc(N_of_Fields);
  RA_point:=To_0_360(RA_point + RA_width);
  One_File;
  {if not File_found then exit}
 end
end;

procedure posi_elm;
 const
 hp1= cl+
 '$@<File with orbital elements of an object>'+cl+
 'should contain (and command-line parameters preceded by $ can change):'+cl+
    +cl+
 '{ {A|Q}# AN# I# E# P{D<yy.mm.dd.ddd>|M#} P{N|L}#'+cl+
 ' | !<string>[:<filename>] }'+cl2;
hp15=
 ' !<string>[:<filename>] will read elements from the line containing <string>'+cl+
 '   using text(!) file <filename> (default xephem.dat, mpc format is,'+cl+
 '   an alternative, in this case >mpc< should be contained in the file name'+cl2;
 hp2=
 ' A is the large semiaxis'+cl+
 ' AN longitude of ascending node'+cl+
 ' I inclination'+cl+
 ' E numerical excentricity (default 0)'+cl+
 ' PD perihelion date'+cl+
 ' PM perihelion Modified Julian Date'+cl;
hp25=
 '  (moment of perihelion passage can be replaced by:'+cl+
 '  MA mean anomaly, AD that mean Anomaly Date and ev. DM daily mean motion)'+cl;
 hp3=
 ' PL periheloin longitude (= PN + AN)'+cl+
 ' PN elongation of perihelion from ascending node'+cl+
 ' Q  perihelion distance from the Sun'+cl2;
 hp4= cl+
 'and if needed, also moments and way to be shown :'+cl+
 ' dDD[.MM[.YY]] tHH[.MM[.SS]] UT# B# N# S# M<symbol>'+cl+
 ' UT is the t-UTC difference / 1 h (default 1 from Nov. to March, else 2)'+cl;
 hp4a=
 ' (the parameters concerning time and TT'+cl+
 '  may be given without $ as well for initialization)'+cl2;
 hp5=
 ' B previous times to be computed (default 0)'+cl+
 ' N next times to be computed (default 0)'+cl+
 ' NT do not show times (and dates) by each position'+cl+
 ' S step to further time (default 1 day)'+cl+
 ' M string to be shown at each place (default +)'+cl;
 hp6=cl+
 'If more than one $@<file> is given on command line, only those parameters '+cl+
 'are valid for the current $@<file>, which are given before the following'+cl+
 '$@<file>.'+cl+cl;
hp7=
 'For a $@<file> given inside a @<file>, just the rest of the same line is sought'+cl+
 'for occurence of any $<parameter>, not the whole @<file>.'+cl;

 step:real=1;
 Before:word=0;
 Next:word=0;
{ Kind:byte=3;}
{ O_Name:string='object';}
 Symb:string[10]='+';
 Comet_No:byte=0;
 Write_time:boolean=true; {Show time by each position}

 var
 xe,ye,ze,r,l,b,ls,lg,bg,rg,drp,eph_time,OSM,OJD:real;
 mp,dp:word;
 yp:integer;
 par_j,jj:byte;
 elm_file_name:Pathstr;

 procedure Help_p(s:string);
  var ch:char;
  begin
   gm_close;
   if s<>'' then writeln(s);
   write(hp1,hp15,hp2,hp25,hp3,h0);
   ch:=readkey;
   if UpCase(ch)= 'Q' then halt;
   write(h0clear,hp4,hp4a,hp5,h0last);
   ch:=readkey;
   if UpCase(ch)= 'Q' then halt;
   write(h0clear,hp6,hp7);
   halt
  end;

 procedure help_p_file;
 var h_file:text;
 begin
  if rt_append('',h_file,'Map_mGSC.hlp') then
   begin
    write(h_file,hp1,hp15,hp2,hp25,hp3,hp4,hp4a,hp5,hp6,hp7);
    close(h_file);
    gm_close;
    halt
   end
  else help_p('');
 end;

 procedure one_p_param;
  var ParOrgCase:string;
  begin
   if (Par[1]='/') or (Par[1]='-') then
    Par:=copy(Par,2,length(par)-1);
   if UpCase(Par[1])='M' then
    Symb:=copy(Par,2,length(Par)-1)
   else
    begin
     ParOrgCase:=Par;
     Par:=__cvtstr(Par,_To_UpCase_Str);
     case Par[1] of
      '?','-': Help_p(''); {- added to respect unix --help even without the help}
      'H': Help_p_file;
      '!': begin
            if ItemCountD(':',Par)>1 then
             ElmCatNameDefault:=ItemStrD(':',2,ParOrgCase);
            if pos('mpc',ElmCatNameDefault)>0 then
             ElmCatNameKind:=2;
            if not get_orbital_elements(
               ElmCatNameKind,
               ElmCatNameDefault,
               ItemStrD(':',1,copy(ParOrgCase,2,length(par)-1))) then
            help(ItemStrD(':',1,copy(ParOrgCase,2,length(par)-1))+' not found');
           end;
      'B': if length(par)>1 then
             Before:=ss2i(par,2);
      'D': if length(Par)>1 then
            if Par[2]='M' then
             begin
              if length(Par)>2 then daily_motion:=ss2r(Par,3);
             end
            else
             if not Par_Date then help_p('') else NewMJD:=true;
      'T': if not Par_Time_or_TT then help_p('') else NewMJD:=true;
      'U': if not Par_UT then help_p('');
      'N': if Par[2]='T' then Write_time:=false
           else Next:=Par2i(Par);
      'A': case Par[2] of
           'N': asc_node:=deg_to_rad(ss2r(Par,3));
           'D': begin {YY:MM:DD.dddd decoding}
                  __St2RDtStr(copy(Par,3,length(Par)-1),YP,MP,DP,DRP,_ANSI_Dt_Str);
                  anomaly_date:=JD0(YP,MP,trunc(DRP))+frac(DRP)-JD_MJD
                end;
           else
            semiaxis_large:=Par2r(par);
           end;
      'E': excentricity:=Par2r(par);
      'I': inclin:=deg_to_rad(Par2r(par));
      'M': if length(Par)>2 then if Par[2]='A' then mean_anomaly:=ss2r(Par,3);
      'P': case Par[2] of
            'N': perih_from_asc_node:=
                  deg_to_rad(ss2r(par,3));
            'L': perih_comp_length:=
                  deg_to_rad(ss2r(par,3));
            'D': begin {YY:MM:DD.dddd decoding}
                  __St2RDtStr(copy(Par,3,length(Par)-1),YP,MP,DP,DRP,_ANSI_Dt_Str);
                  perih_pass:=JD0(YP,MP,trunc(DRP))+frac(DRP)-JD_MJD
                 end;
            'M': perih_pass:=ss2r(par,3);
           end;
       'S': step:=par2r(par);
       'Q': perihel_dist:=par2r(Par);
     end; {of case}
    end;
  end;

 procedure do_elm_file;
  const Comet_No_loc:byte=0;
  var jjj,ic:byte;
      elm_remark:boolean;
      elm_file:text;
      elm_line,Day:string;
      disp_times:boolean;
      YYYYold,MMold:word;
      NDold,j:integer;
      X,Y:longint;
  begin
   comet_no_loc:=0;
   Write_time:=true;
   elm_file_Name:=copy(par,3,length(par)-2);
   if not rt_reset_suf( Loc_Obj,elm_file,elm_file_name,'elm') then
    help_p('@ file >>'+elm_file_name+'<< not found');

   while not eof(elm_file) do      {processing the $@<file>}
    begin
     readln(elm_file,elm_line);
     elm_remark:=false;
     ic:=itemcount(elm_line);
     for jjj:= 1 to ic do
      begin
       Par:=itemstr(jjj,elm_line);
       if Par[1] in rem_char then elm_remark:=true;
       if not elm_remark then one_p_param;
      end;
    end;
   close(elm_file);
   elm_remark:=false;

   if Par_file_name<>'' then
    if jj<i then                    {processing the rest of the @<file> line}
     for jjj:= jj+1 to i do
      begin
       Par:=itemstr(jjj,par_line);
       if Par[1] in rem_char then remark:=true;
       if not remark then
        if (Par[1]='$') then
         one_p_param;
      end;

   ic:=itemcount(command_line);     {processing the command line}

   for jjj:= 1 to ic do
    begin
     Par:=itemstr(jjj,command_line);
     case Par[1] of
      '&': elm_remark:=true;
      '$': begin
            par:=copy(par,2,length(par)-1);
            if par[1]='@' then
             begin
              inc(Comet_no_loc);
              if Comet_no_loc>comet_no then elm_remark:=true;
             end;
            if not elm_remark then one_p_param;
           end;
     end;
    end;

   if NewMJD then
    begin
     OSM:=SM;
     OJD:=JD;
     Get_JD;
     if not tt_UT_set then tt_ut:=tt_UTC_in_days(JD);
     SM:=OSM;
     JD:=OJD;
    end
   else MJD:=JD-JD_MJD;
   if Perih_comp_length<>-999 then
    perih_from_asc_node:=perih_comp_length-asc_node;

   if asc_node=-999 then
    help_p('Longitude of ascending node (an) is missing.');
   if perih_from_asc_node=-999 then
    help_p('Elongation of perihelion from ascending node (pn) is missing.');
   if inclin=-999 then
    help_p('Inclination (i) is missing.');
   if semiaxis_large=-999 then
    if perihel_dist=-999 then
     help_p('Both large semiaxis (a) and perihelion distance (q) are missing.')
    else
     semiaxis_large:=0;
   if perihel_dist=-999 then perihel_dist:=0;
   if perihel_dist=-999 then perihel_dist:=0;
   if perih_pass=-999 then
    if anomaly_date>-998 then
     if mean_anomaly>-998 then
      begin
       if (daily_motion>-998) and (daily_motion<>0) then
        perih_pass:= anomaly_date-(mean_anomaly/daily_motion)
       else
        if semiaxis_large>0 then
         perih_pass:= anomaly_date-
          (mean_anomaly*sqrt(semiaxis_large*sqr(semiaxis_large))*365.255/360)
        else
         perih_pass:= anomaly_date-
          (mean_anomaly*sqrt(perihel_dist/(1-excentricity)
                        *sqr(perihel_dist/(1-excentricity)))*365.255/360)
       end
      else
       help_p(
  'Time of perihelion passage (pM) (or mean anomaly and its date) is missing.');

    if round(10*step) mod 10 = 0 then disp_times:=false
    else disp_times:=true;
    for j:=-Before to Next do
     begin
      eph_time:=MJD+step*j;
      Planet_hel(3,eph_time+jd_MJD+tt_ut,l,b,r,Day);
      ls:=bas_int(l+180,360);
      object_hel(
       semiaxis_large,
       perihel_dist,
       excentricity,
       inclin,
       asc_node,
       perih_from_asc_node,
       perih_pass,
       eph_time,
       xe,ye,ze,r);
      c3_to_Pd(xe,ye,ze,r,l,b);
      Hel_to_Geo(eph_time+JD_MJD+tt_ut,l,b,r,lg,bg,rg);
      LB_RD(lg,bg,RA,Decl);
      if MapCoord(RA,Decl,X,Y) then
       begin
        gm_outxy(x,y,Symb,'c',0);
        if Write_time then
         begin
          Day:=DoW(eph_time+JD_MJD,t_UT,1);
          if (not disp_times) and (j<>0) then
           Time:=''
          else
           Time:=copy(Time,1,5);
          if (step>5) and (j<>0) then
           Day:=' '
          else
           Day:='('+copy(Day,1,3)+')';
          Day:=__Dt2StStr(YYYY,MM,ND,_ANSI_Dt_Str)+Day;
          if j=-Before then
           begin
            YYYYold:=YYYY;
            MMold:=MM;
            NDold:=ND
           end
          else
           if YYYYold=YYYY then
            begin
             Day:=copy(Day,5,length(Day)-4);
             if MMold=MM then
              begin
               Day:=copy(Day,4,length(Day)-3);
               if NDold=ND then
                Day:=' '
               else
                NDold:=ND;
              end
             else
              begin
               MMold:=MM;
               NDold:=ND;
              end
            end
           else
            begin
             YYYYold:=YYYY;
             MMold:=MM;
             NDold:=ND;
            end;
          gm_outxtxy(x,y,'',Day+Time,'','l',0,Textwidth(symb)*16,0)
         end;
       end;
     end;
   {close(par_file);}
   Symb:='+';
   NewMJD:=false;
  end;

 begin
  if paramcount=0 then exit;

  for par_j:= 1 to paramcount do
   begin
    Par:=paramstr(par_j);
    case Par[1] of
    '@':
     begin
      par_file_name:=copy(par,2,length(par)-1);
      if not rt_reset_suf(Loc_Obj,par_file,par_file_name,'cnf') then
       help_p('@ file >>'+par_file_name+'<< not found');
      while not eof(par_file) do
       begin
        readln(par_file,par_line);
        remark:=false;
        i:=itemcount(par_line);
        for jj:= 1 to i do
         begin
          Par:=itemstr(jj,par_line);
          if Par[1] in rem_char then remark:=true;
          if not remark then
           if (Par[1]='$') and (Par[2]='@') then
            do_elm_file;
         end;
       end;
      close(par_file);
      par_file_name:=''
     end;
    '$':
     case UpCase(Par[2]) of
       '@':
         begin
          inc(Comet_No);
          do_elm_file
         end;
       '?': help_p('');
       'H': help_p_file;
     end;
    end;
   end;

 end; {of posi_elm}

procedure one_Map_mGSC_param;
const first_two_finished:boolean=true; first_finished:boolean=true;
var ParOrgCase:string;
begin
 if pos('?',ParOrg)>0 then help('');
 repeat {to eventually reprocess the first two parameters, if they are not
         positional ones}
  Par:=__cvtstr(ParOrg,_to_UpCase_Str);
  if (Par[1]='/') or (Par[1]='-') then
   Par:=copy(Par,2,length(Par)-1);
  if Par='H' then help_file;
  case next_par of
   1:begin    {RA or 'DB' or var.star first name}
      if copy(Par,1,2)='RA' then
       Par:=copy(Par,3,length(ParOrg)-2)
      else
       Par:=ParOrg;
      val(Par,ra_centre,code);
      if code > 0 then
       begin
        if BabS2DecO(Par,RA_centre,'H') then
         begin
          RA_centre:=RA_centre*15;
          RA_known:=true;
          next_par:=2
         end
        else
         begin
          if __cvtstr(Par,_to_upcase_str)='DB' then
           next_par:=3
          else
           begin
            next_par:=4;
            aux_s:=ParOrg;
           end
         end
       end
      else
       begin
        RA_known:=true;
        next_par:=2;
       end;
     end;
   2:begin    {declination}
      if copy(Par,1,2)='DE' then
       Par:=copy(ParOrg,3,length(ParOrg)-2)
      else
       Par:=ParOrg;
      val(Par,Dec_centre,code);
      if code > 0 then
       if not BabS2DecO(Par,Dec_centre,'D') then
         help_string:=ParOrg+' is no good declination'
       else coord_known:=true
      else
       coord_known:=true;
      next_par:=0;
     end;
   3:begin        {binary star designation}
      if not get_bin(ParOrg,RA_centre,Dec_centre,NoR) then
        help('The second parameter denotes no binary within Binaries.dbf')
      else
       if (RA_Centre=0) and (Dec_centre=0) then
        help('The coordinates are not given for this star in Binaries.dbf')
       else
        Coord_known:=true;
      DbClose;
      next_par:=0;
     end;
   4:begin        {variable star constellation name}
      if not get_gcvs(aux_s,ParOrg,RA_centre,Dec_centre,NoR) then
       begin
        help_string:=
         'the first parameter is no Right Ascension nor var. star designation!';
        first_two_finished:=false;
        first_finished:=false;
       end
      else
       Coord_known:=true;
      DbClose;
      next_par:=0;
     end;
   else            {parameter defined by label, not position}
     begin
       if first_finished then
        begin
         Par:=ParOrg;
         first_two_finished:=true;
        end
       else
        begin
         Par:=aux_s;
         first_finished:=true;
        end;
       if (Par[1]='/') or (Par[1]='-') then
        Par:=copy(Par,2,length(Par)-1);
       ParOrgCase:=Par;
       Par:=__cvtstr(Par,_to_UpCase_Str);
       case Par[1] of
       'B': MinX:=par2i(Par);
       'D': if Par[2]='E' then
             begin
              Par:=copy(par,3,length(par)-2);
              val(Par,Dec_centre,code);
              if code>0 then
               if not BabS2DecO(Par,Dec_centre,'D') then
                help(Par+' is no good declination')
               else Decl_known:=true
              else Decl_known:=true;
             end
            else
             if Par_Date then NewMJD:=true ;
       'E': begin
             Year:=par2r(Par);
             if PrecInit(Year,2000) then Precess(RA_centre,Dec_centre);
            end;
       'F': begin
             aux_s:=copy(Par,2,length(Par)-1);
             case aux_s[1] of
              'L':begin
                   Faintness_lim:=par2i(Aux_s);
                   if Faintness_lim<50 then
                    begin
                      writeln('Faintness_lim of ',Faintness_lim:3,
                      ' dmag is probably an error. Give another number, please:');
                      readln(Faintness_lim)
                    end;
                  end;
              'B':Faintness_base:=par2i(Aux_s);
              'D':Faintness_desc:=par2i(Aux_s);
             end;
            end;
       'G': if (length(Par)=1) then
            else
             if Par[2]='R' then
              if Length(Par)=2 then
               begin                 {grid}
               end
              else
               begin
                code:=ss2i(Par,3);
                if code=2 then
                 gray16_stars:=false  { black & white screen}
                else
                 if code in [3..100] then
                                    {texts at wrtcolour % of the maximum white}
                  wrtcolour:=code;
               end;
       'H': help_file;
       'K': Kind:=par2i(Par);
       'L': if length(Par)>2 then
             case par[2] of
              'M': begin
                    Loc_GSC:=copy(ParOrgCase,3,length(Par)-2);
                    if Loc_GSC[length(Loc_GSC)] in ['\','/'] then
                     Loc_GSC:=Loc_GSC+Loc_GSC_loc;
                   end;
              'E': Loc_obj:=copy(ParOrgCase,3,length(Par)-2);
              'V': Loc_GCVS:=copy(ParOrgCase,3,length(Par)-2);
             end;
       'M': Mirror:=true;
       'N': if length(Par)=1 then Max_Param:=0 else Max_Param:=Par2i(Par);
       'P': mode:=par2i(Par);
       'R': if Par[2]='A' then
             begin
              Par:=copy(Par,3,length(Par)-2);
              val(Par,RA_centre,code);
              if code>0 then
               if not BabS2DecO(Par,RA_centre,'H') then
                help(ParOrg+' is no good Right ascension')
               else RA_known:=true
              else RA_known:=true;
             end
            else
             begin
              if Par[2]='O' then Par:=copy(par,2,length(par)-1);
              Rot_Angle:=-pi*par2r(Par)/180;
             end;
       'S': begin
             if length(Par)>3 then
              if copy(Par,2,3)='VGA' then
               Par_SVGA
              else Size_in_Dec:=par2r(Par)
             else Size_in_Dec:=par2r(Par);
             if Size_in_Dec<0.01 then
              help('S... gives no good size of field nor SVGA mode');
            end;
       'T': if Par[2]='R' then
             ToFont_dmag:=round(10/ss2r(Par,3))
            else if Par_Time_or_TT then NewMJD:=true;
       'U': if Par_UT then NewMJD:=true;
       'W': if (Par[2] in ['1','2','3']) then
             begin
              val(Par[2],GM_Mode,code);
              GM_OuFile:=copy(ParOrgCase,3,length(Par)-2)
             end
            else
             begin
              WFile:=true;
              assign (out,copy(ParOrgCase,1,length(Par)-1));
              rewrite(out);
              writeln(out,'RA degrees Decl. dmag Pl Class');
             end;
       'X': if length(Par)>1 then
             case Par[2] of
             'S': XS:=ss2i(Par,3);
             end
            else
             Small_size_in_Dec:=par2r(Par);
       'Y': if length(Par)>1 then
             case Par[2] of
             'S': YS:=ss2i(Par,3);
             end;
       end
     end;
  end;
 until first_two_finished;
end;

procedure FurtherBelts(North:boolean);
var NB,NofBelts,N_of_Belt_o:byte; sig_o:shortint;
begin
 If North then
  NofBelts:=  (trunc(2*Dec_centre+225 + Size_in_Dec)) div 15
            - (trunc(2*Dec_centre+225              )) div 15
 else
  NofBelts:=  (trunc(2*Dec_centre+225              )) div 15
            - (trunc(2*Dec_centre+225 - Size_in_Dec)) div 15;
 Dec_point:= sig*3.5 + Belt_height*( (trunc(2*Dec_centre)+225 ) div 15 - 15);
 if (sig=-1) and (abs(frac(Dec_centre/Belt_height))<1e-3) then
  if North then inc(NofBelts) else if NofBelts>0 then dec(NofBelts);
 if NofBelts>0 then for NB:=1 to NofBelts do
  begin
   If North then
    Dec_point:=Dec_point + Belt_height
   else
    Dec_point:=Dec_point - Belt_height ;
   if abs(Dec_point)<90 then
      {this condition handles pole-behind tiles}
    begin
     N_of_Belt_o:=N_of_Belt;
     sig_o:=sig;
     OpenFile(RA_centre,Dec_Point);
     if (N_of_Belt_o=N_of_Belt) and (sig_o=sig) then {skip the same band}
      close(inp)
     else
      begin
       j_max_orig:=j_max;
       PlotMap;
       SidesOfBelt;
      end;
    end;
  end;
end;

begin                       { Of the MAIN Programme }
FileMode:=0; {will open the files by reset as Read Only
              -- they could be now marked so even when not on CD}
GM_mode:=0;
highvideo;

if paramcount>0 then
 begin
  command_line:='';
  for i:= 1 to paramcount do
   command_line:=command_line+paramstr(i)+' ';
  remark:=false;
  i:=itemcount(command_line);
  for j:= 1 to i do
   begin
    ParOrg:=itemstr(j,command_line);
    if ParOrg[1] in rem_char then remark:=true;
    if not remark then
     case ParOrg[1] of
     '@':
      begin
       par_file_Name:=copy(ParOrg,2,length(ParOrg)-1);
       if not rt_reset_suf(Loc_Obj,par_file,par_file_name,'cnf') then
        help('@ file >>'+par_file_name+'<< not found');
       while not eof(par_file) do
        begin
         readln(par_file,par_line);
         remark_cfg:=false;
         i_cfg:=itemcount(par_line);
         for j_cfg:= 1 to i_cfg do
          begin
           ParOrg:=itemstr(j_cfg,par_line);
           if ParOrg[1] in rem_char then remark:=true;
           if not remark_cfg then one_Map_mGSC_param;
          end;
        end;
       close(par_file);
       par_file_name:='';
      end;
     '$': if length(ParOrg)=2 then
           if ParOrg[2] in ['h','H','?'] then begin lowvideo; posi_elm; end;
     else
      one_Map_mGSC_param;
     end;
   end;
 end {of if paramcount>0}
else help('');

if not Coord_known then
 begin
  writeln(RA_known,Decl_known);
  Coord_known:=RA_known and Decl_known;
 end;

if not Coord_known then help(Help_string);

if RA_centre<0 then RA_centre:=RA_centre+360;

if Faintness_Desc=200 then Faintness_desc:=Faintness_base;

if GM_mode<>2 then
 begin
  count_f:=110;
  min_ps_r:=2;
 end;
GM_init(xs,ys);
gm_setVstep(400);
if MinX>0 then MinX:= MaxX div 100 * MinX;
RigX:=round((MaxX/640.0) * 594.0)-1; {to be 593 at VGA}
CenX:=MinX+(RigX+1-MinX) div 2;
CenY:=MaxY div 2;

Scale:= MaxY / Size_in_Dec;
        {vertical number of pixel/pix1 per VERTICAL side }
ScaleR:= Scale*180/pi;

Aux_r:=cos(deg_to_rad(Dec_Centre));
if (Dec_Centre+Size_in_Dec/2<90)
and (Dec_Centre-Size_in_Dec/2>-90) then {no pole inside}
 begin
  RA_min:=To_0_360(RA_centre-125*Size_in_Dec/(2*Aux_r*ys));
  RA_max:=To_0_360(RA_centre+125*Size_in_Dec/(2*Aux_r*ys));
  if RA_max > RA_min then Around0:= false else Around0:=true
 end
else
 begin
  RA_min:=0;
  RA_max:=360;
  Around0:=true;
  if kind=0 then kind:=1;
 end;
if (abs(dec_centre)>89) and (kind=0) then kind:=1;
if kind>0 then
 begin
  mat(Ma_Ah_to_td,2,pi/2-deg_to_rad(Dec_centre));
          {transformation matrix for Rotation to projection center}
  if Rot_angle<>0 then
   begin
    mat(Mat_aux,3,Rot_angle);
    matl_mat(Mat_aux,Ma_Ah_to_td);
   end;
 end
else
 RA_Scale:= Scale * Aux_r;

if gray16_stars then
 begin
  wrtcolour:= (wrtcolour*GetMaxColor) div 100;
  setcolor(wrtcolour);
  gm_Star_full_mode:=NormalPut{star_full_mode_ori};
 end
else
 wrtcolour:=GetMaxColor;

if small_size_in_dec<>100 then
 begin
  gm_comm(cl+'% Small rectangle:');
  zl:=((size_in_dec)/(small_size_in_dec));
  gm_rectangle(round(cenx-(cenx/zl)),round(ceny+(ceny/zl)),round(cenx+(cenx/zl)),round(ceny-(ceny/zl)));
 end;


    gm_comm(cl+'% line between the map and its description:');
gm_line(RigX,0,RigX,MaxY);
    gm_comm(cl+'% center cross:');
gm_line(CenX -pix3,CenY,CenX +pix3,CenY);
gm_line(CenX, CenY -pix3, CenX, CenY +pix3);
description;
RA_C:=RA_centre;
posi_elm;

   gm_comm(cl+'% Stars:');
OpenFile(RA_centre,Dec_centre);
j_max_orig:=j_max;
PlotMap;

Dec_Point:=Dec_centre;
SidesOfBelt;
FurtherBelts(false); {southwards}
FurtherBelts(true);  {northwards}

if File_found and (GM_mode=3) then plot_rest;

if WFile then  close(out);

moveto(10,0);
outtext('Finished');

repeat until Keypressed;
(*cH:=Box(CenX,CenY,5,5);*)

ch:=readkey;
if ch=#0 then
 begin
  ch:=readkey;         {PrintScreen}
  if ch=#114 then PriGScr('',0,mode)
 end
else
 if UpCase(ch)='P' then PriGScr('',0,mode)
 else
  begin
   aux_s:=ch;
   val(aux_s,i,j);
   if J=0 then PriGScr('Map_mGSC',i,mode);
  end;

if (UpCase(ch)='N') or (UpCase(ch)='B') then   {new centre}
 begin
 end
else
 if UpCase(ch)<>'G' then gm_close;   {G leaves the map on the screen}
end.
