 {~ Positions of a body from elements of its heliocentric trajectory ~}

program Posi;
(*  Copyright (C) 1999 Jan Hollan

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)

uses angles_o, solar_ut,params,un_str_m,str_num,planets,elm;

const

h10=cl+
'A program from Jan Hollan, N.Copernicus Obs. and Planetarium, April 1997,'+cl+
' (subject to the GNU General Public License, http://www.gnu.org/copyleft,'+cl+
'  source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'+cl2;
h11=
'gives coordinates of an object (using a procedure by Rudolf Novak):'+cl2;

h20=
'Posi  @<file with any command-line parameters>'+cl+
'  dDD[.MM[.YY]] { tHH[.MM[.SS]] | t{m|e|b}[#] } UT# L# K# N# NE S# C'+cl+
' { {A|Q}# I# E# {P[D<yy.mm.dd.ddd>|M#] | MA# AD# [DM#]}  P[L|N]# AN# FA# CE[#] '+cl+
' | !<string>[:<filename>] }'+cl2;
h30=
'Initial values of D and T are taken from the system date and time'+cl+
' tM[#] is a Morning time when Sun is # degrees below horizon (default 12)'+cl+
'  (E for Evening, B for Both)'+cl;
h40=
' UT is the t-UTC difference / 1 h (default 1 from Nov. to March, else 2)'+cl+
' L  is the longitude of the observing place, default that of '
  +MyLocation_Name+','+cl;
h50=
' F  is the latitude      -               "                -  '+cl+
' K  the kind of coordinates to be displayed:'+cl+
'  1  heliocentric ecliptic coordinates'+cl+
'  2  geocentric ecliptic coordinates (default)'+cl+
'  3  geocentric equatoreal coordinates'+cl;
h60=
'  4  topocentric horizontal coordinates'+cl;
h62=
' N next times to be computed (default 0); Uranus to Pluto are skipped'+cl+
' NE do not append explanation of the last columns of the table'+cl+
' S time step for each new position / 1 day (default 1 day)'+cl+
'    (#h  for # / 1 hour, #m for time step in minutes)'+cl2;

h70=
' C write just one RA and Decl. (as an input to another programme)'+cl2+

' FA is an absolute faintness / 1 cmag '+cl+
'    (how faint it would be at 1 AU from both Earth and Sun'+cl+
'     and at an imposible zero phase angle (angle Sun-object-Earth)'+cl;
h71=
'    photometric ephemeris is included when FA is given'+cl+
' CE is a "Cometary Exponent" (default 4 when present, as usual for new comets,'+cl+
'    2 when not present as for minor planets, for some comets it may be even 5)'+cl;
h72=
' Z  is zenith extinction / 1 cmag (default 30) '+cl2;

h80=
'And now the orbital elements, when not given in the @file (or to replace them):'+cl+
' A is the large semiaxis | Q the perihelion distance'+cl+
' I inclination'+cl+
' E numerical excentricity (default 0)'+cl+
' PD perihelion date'+cl+
' PM perihelion Modified Julian Date'+cl;
h85=
'  (moment of perihelion passage can be replaced by:'+cl+
'  MA mean anomaly, AD that mean Anomaly Date and ev. DM daily mean motion)'+cl;
h90=
' PL periheloin longitude (= PN + AN)'+cl+
' PN elongation of perihelion from ascending node'+cl+
' AN longitude of ascending node'+cl2;
h95=
' !<string>[:<filename>] will read elements from the line containing <string>'+cl+
'   using text(!) file <filename> (default xephem.dat, mpc format is,'+cl+
'   an alternative, in this case >mpc< should be contained in the file name'+cl2;
h100=
' ?  gives this explanation of input,'+cl+
' h  creates file Posi.hlp with this explanation of input'+cl;

step:real=1;
Next:word=0;
Kind:byte=2;
{O_Name:string='object';}

Sun_depth:real=12;
 {Solar depth / 1 degree, default at the verge of nautical night}
Just_coord:boolean=false; {just RA and Decl as an input to generating a map}
Morning_or_evening:char=' ';  {M for Morning, E for Evening, B for Both}
{Comet:boolean=false;
Comet_exponent:real=2;
Faint_abs:real=-20;
}
first_line:string=''; {first line of *.elm
                       to the ouput, if it is a comment line}
far_s:string[80]=' degrees far'+cl+
 '                                                             ';
days_s:string[9]=' days old';
Zenith_Ext:real=0.3; {magnitudes}
Explanation:boolean=true;
Par_File_read:boolean=false;


he0=
' time (UTC ';
he1:array[2..5] of string[50]=(
                ' h)       longitude       latitude          long.',
                ' h)    right ascension   declination          RA ',
                ' h)      azimuth      angular height        RA   ',
                ' h)       hour angle     declination          RA ');
he11=           ' h)         longitude       latitude        far from Sun';
he2f=                                                              '  faint';
he3=                                                                    '  PhAn';
he4h=cl+
'                        from South                    far  -_Sun  ';
he4=cl+
'                                                        far  -_Sun  ';
he5fp=                                                             '     +';
he6h=cl+
'--------------------  --------------  --------------  ---- ----- ';
he6=cl+
'----------------------- --------------  --------------  ---- ----- ';
he61=cl+
'-----------------------  ----------------  ---------------  ----';
he7f=                                                            '---- ';
he7fp=                                                                '---';
he7fm=                                                                ' ';
he8=                                                                     ' ---';
he9hf=cl+
'year-month-day hh:mm  degrees  hh:mm  degrees  dd:mm   AU  degr. mag';
he9h=cl+
'year-month-day hh:mm  degrees  hh:mm  degrees  dd:mm   AU    degrees ';
he9f=cl+
'year-month-day hh:mm:ss degrees  hh:mm  degrees  dd:mm   AU  degr. mag';
he9=cl+
'year-month-day hh:mm:ss degrees  hh:mm  degrees  dd:mm   AU    degrees';
he91=cl+
'year-month-day hh:mm:ss  degrees   hh:mm   degrees   dd:mm   AU';
he10fp=                                                              '  mag';
he10fm=                                                              '   ';
he10=                                                                    ' dg.';


var
xe,ye,ze,r:{double -- that has been some attepmt, perhaps for some almost
             parabolic trajectory, to avoid errors; I hope I found another
             solution later, so real should probably do again}
            real;
l,b,ls,lg,bg,rg,drp,eph_time,faintness,o_ph_a,raux:real;
mp,dp,yyo,mmo:word;
yp,ndo:integer;
j,jj:byte;
Name:string;
par_file,h_file:text;
par_line,ParOrg:string;
remark:boolean;
MoE:char;

procedure Help(s:string);
begin
 if s<>'' then writeln(s);
 write(h10,h11,h20,h30,h40,h50,h60,h0enter);
 cont_or_halt;
 write(h0clear,h62,h70,h71,h72,h0enter);
 cont_or_halt;
 write(h0clear,h80,h85,h90,h95,' ',h_dir_elem,h0enter);
 cont_or_halt;
 write(h0clear,cl,h_refraction,cl,hTT,cl,h100);
 halt
end;

procedure Help_f;
begin
 if rt_rewrite(h_file,'Posi.hlp') then
  begin
   write(h_file,h10,h20,h30,h40,h50,h60,
               h62,h70,h71,h72,
               h80,h85,h90,h95,' ',h_dir_elem,cl,h_refraction,h100);
   close(h_file);
  end
 else help('');
 halt
end;

 procedure  Is_Moon_there;
  var f,pa,ad,l_obj,b_obj,R:real; Moon_over_hor:boolean;
  begin
   l_obj:=l;
   b_obj:=b;
   moon_geo(jd+tt_ut,l,b,r,f);
   LB_RD(l,b,RA,Decl);
   A:=deg_to_rad(360*SM/24-RA); h:=deg_to_rad(Decl);
   ah_to_td(pi/2-fi,A,h);
   Moon_over_hor:=false;
   if (h>-0.04) then
    begin
     Moon_over_hor:=true;
     r:=r-sin(h);
     h:=h - arctan(cos(h)/r);
     lg:=A; bg:=h;
     A:=rad_to_deg(A);
     if A>180 then A:=A-360;
     h:=rad_to_deg(h);
     lg:=rad_to_deg(lg);
     bg:=rad_to_deg(bg);
     pa:=deg_to_rad(-(l_obj-lg));
     ad:=deg_to_rad(bg);
     ah_to_td(deg_to_rad(90-b_obj),pa,ad);
     {pa:=Bas_Int(180+rad_to_deg(pa),360);}
     ad:=90-rad_to_deg(ad);
    end;
   if Moon_over_hor then
    begin
     writeln(
'                Moon: ',
      lg:5:1,'  = '+deg_to_HM(lg),'  ',bg:5:1,
      ad:18:0,far_s,
      Bas_Int(l-ls,360)/360*29.53059:4:0,days_s);
     far_s:=''; days_s:='';
    end;
  end;

procedure one_param;
begin
   if (Par[1]='/') or (Par[1]='-') then
     Par:=copy(Par,2,length(par)-1);
   ParOrg:=Par;
   Par:=__cvtstr(Par,_To_UpCase_Str);
   case Par[1] of
    '?','-': Help(''); {- added to respect unix --help even without the help}
    '!' : begin
           if ItemCountD(':',Par)>1 then
            ElmCatNameDefault:=ItemStrD(':',2,ParOrg);
           if pos('mpc',ElmCatNameDefault)>0 then
            ElmCatNameKind:=2;
           if not get_orbital_elements(
              ElmCatNameKind,
              ElmCatNameDefault,
              ItemStrD(':',1,copy(ParOrg,2,length(par)-1))) then
           help(ItemStrD(':',1,copy(ParOrg,2,length(par)-1))+' not found');
          end;
    'A': case Par[2] of
         'N': asc_node:=deg_to_rad(ss2r(Par,3));
         'D': begin {YY:MM:DD.dddd decoding}
                __St2RDtStr(copy(Par,3,length(Par)-1),YP,MP,DP,DRP,_ANSI_Dt_Str);
                anomaly_date:=JD0(YP,MP,trunc(DRP))+frac(DRP)-JD_MJD
              end;
         else
          semiaxis_large:=Par2r(par);
         end;
    'C': if length(par)>1 then
          case Par[2] of
          'T': if not par_celtemp then help('');
          'E':
           begin
            if length(Par)>2 then
             Comet_exponent:=ss2r(Par,3)
            else
             Comet_exponent:=4;
            Comet:=true;
           end
          end
         else
          Just_coord:=true;
    'D': if length(Par)>1 then
          if Par[2]='M' then
           begin
            if length(Par)>2 then daily_motion:=ss2r(Par,3);
           end
          else
           if not Par_Date then help('');
    'E': excentricity:=Par2r(par);
    'F': if length(par)>1 then
          if Par[2]='A' then
           Faint_abs:=ss2r(Par,3)/100
          else
           if not (Par[2] in ['A'..'z']) then if not Par_Fi then ;
    'H': if length(par)=1 then help_f;
    'I': inclin:=deg_to_rad(Par2r(par));
    'K':begin
         Kind:=Par2I(Par);
         if not(Kind in [1..5]) then
          help('The /K parameter is outside 1..5');
        end;
    'L': if length(Par)>2 then
          case par[2] of
           'E': Loc_obj:=copy(Par,3,length(Par)-2);
          else if not Par_Lambda then help('');
          end
         else if not Par_Lambda then help('');
    'M': if length(Par)>2 then if Par[2]='A' then mean_anomaly:=ss2r(Par,3);
    'N': if length(Par)>1 then
          case Par[2] of
           'E': Explanation:=false;
           else
            Next:=Par2i(Par);
          end;
    'P': case Par[2] of
          'N': perih_from_asc_node:=
                deg_to_rad(par2r(copy(Par,2,length(Par)-1)));
          'L': perih_comp_length:=
                deg_to_rad(par2r(copy(Par,2,length(Par)-1)));
          'D': begin {YY:MM:DD.dddd decoding}
                __St2RDtStr(copy(Par,3,length(Par)-1),YP,MP,DP,DRP,_ANSI_Dt_Str);
                perih_pass:=JD0(YP,MP,trunc(DRP))+frac(DRP)-JD_MJD
               end;
          'M': perih_pass:=par2r(copy(Par,2,length(Par)-1));
          'P': if not par_relpres then help('');
         end;
    'R': if not par_relhum then help('');
    'S': if par[2] in ['.','0'..'9'] then
         begin
          if pos('H',Par)>0 then
           Step:=par2r(copy(Par,1,pos('H',Par)-1))/24
          else
           if pos('M',Par)>0 then
            Step:=par2r(copy(Par,1,pos('M',Par)-1))/24/60
           else
            Step:=par2r(Par);
         end;
    'T': if length(Par)>1 then
          case Par[2] of
           'M','E','B': begin
            Morning_or_evening:=par[2];
            if length(Par)>2 then
             Sun_depth:=ss2r(par,3);
               end;
           'I': {enabling Tycho input for Map_BSC};
           else if not Par_Time_or_TT then help('Unknown T paramater: '+par);
          end;
    'U': if not Par_UT then help('');
    'Q': perihel_dist:=par2r(Par);
    'Z': begin Zenith_Ext:=Par2r(Par)/100; if Zenith_Ext<0.15 then
              help('Zenith extinction cannot be under 15 cmag.') end;
   end; {of case}
end;

begin
 Air_mass:=-1;
 if paramcount=0 then help('');
 j:= 1;
 repeat
   Par:=paramstr(j);
   if Par[1]='@' then
    begin
     Name:=copy(par,2,length(par)-1);
     if not rt_reset_suf(Loc_Obj,par_file,name,'elm') then
      help('@ file >>'+name+'<< not found');
     first_line:='first line';
     while not eof(par_file) do
      begin
       readln(par_file,par_line);
       remark:=false;
       for jj:= 1 to itemcount(par_line) do
        begin
         Par:=itemstr(jj,par_line);
         if Par[1] in ['&','%','#'] then remark:=true;
         if First_line='first line' then
          begin
           First_line:='';
           if remark then
            first_line:='Ephemeris is based on file beginning with:'+cl+
                     par_line;
          end;
         if not remark then one_param;
        end;
      end;
     close(par_file);
     Par_file_read:=true;
    end;
   inc(j);
 until Par_File_read or (j>paramcount);
 for j:= 1 to paramcount do
  begin
   Par:=paramstr(j);
   one_param;
  end; {of for}

 Get_JD;
 if not tt_UT_set then tt_ut:=tt_UTC_in_days(JD);
 if Morning_or_evening<>' ' then
  begin
   MoE:=Morning_or_evening;
   if Morning_or_evening='B' then
    MoE:='M';
   if not At_height(MoE,-Sun_depth,MJD) then halt;
   JD:=MJD+JD_MJD;
   Name:=DoW(JD,t_UT,_English);
   DD:=ND;
   Get_JD;
   step:=trunc(step);
   if step=0 then step:=1;
  end;

 if Perih_comp_length<>-999 then
  perih_from_asc_node:=perih_comp_length-asc_node;

 if asc_node=-999 then
  help('Longitude of ascending node (an) is missing.');
 if perih_from_asc_node=-999 then
  help('Elongation of perihelion from ascending node (pn) is missing.');
 if inclin=-999 then
  help('Inclination (i) is missing.');
 if semiaxis_large=-999 then
  if perihel_dist=-999 then
   help('Both large semiaxis (a) and perihelion distance (q) are missing.')
  else
   semiaxis_large:=0;
 if perihel_dist=-999 then perihel_dist:=0;
 if perih_pass=-999 then
  if anomaly_date>-998 then
   if mean_anomaly>-998 then
    begin
     if (daily_motion>-998) and (daily_motion<>0) then
      perih_pass:= anomaly_date-(mean_anomaly/daily_motion)
     else
      if semiaxis_large>0 then
       perih_pass:= anomaly_date-
        (mean_anomaly*sqrt(semiaxis_large*sqr(semiaxis_large))*365.255/360)
      else
       perih_pass:= anomaly_date-
        (mean_anomaly*sqrt(perihel_dist/(1-excentricity)
                      *sqr(perihel_dist/(1-excentricity)))*365.255/360)
     end
    else
     help(
'Time of perihelion passage (pM) (or mean anomaly and its date) is missing.');

 if Just_coord then
  begin
   eph_time:=MJD;
   {Planet_hel(3,eph_time+jd_MJD+tt_ut,l,b,rG,Name);}
   object_hel(
    semiaxis_large,
    perihel_dist,
    excentricity,
    inclin,
    asc_node,
    perih_from_asc_node,
    perih_pass,
    eph_time,
    xe,ye,ze,r);
   c3_to_Pd(xe,ye,ze,rG,l,b);
   Hel_to_Geo(eph_time+JD_MJD+tt_ut,l,b,rG,lg,bg,rg);
   LB_RD(lg,bg,l,b);
   writeln('RA',l:4:3,' De',b:4:3);
   halt(1);
  end;

 if First_line<>'' then writeln(first_line);
 if Morning_or_evening<>' ' then
  begin
   write('Ephemeris is made for moment');
   if (Morning_or_evening='B') or (next>0) then
    write('s');
   write(' when Sun is '+SRe(4,1,Sun_depth)+' degrees below horizon');
   case Morning_or_evening of
    'M': write(cl+'  in the morning.');
    'E': write(cl+'  in the evening.');
    else write('.',cl);
   end;
   if Kind=4 then
    writeln(' Moon is mentioned (how far and old) when over horizon.')
   else
    writeln;
  end;

 writeln(cl+'( Orbital elements are:',cl,
  '  a=',  semiaxis_large:9:7,
  '  q=',  perihel_dist:9:7,
  '  e=',  excentricity:9:7,
  '  i=',  inclin:9:7,         cl,
  ' AN=', asc_node:9:7,
  ' PN=', perih_from_asc_node:9:7,
  ' PM=', perih_pass:10:4,' )');

 case Kind of
  1: writeln(cl,'The heliocentric ecliptic coordinates on');
  2: writeln(cl,'The geocentric ecliptic coordinates on');
  3: writeln(cl,'The geocentric equatorial coordinates on');
  4: writeln(cl,'The starting moment is');
 end;

 writeln(yyyy,'-',mm:2,'-',nd:2,'  at ',h_min_s(UT),', expressed in UTC, or');
 Name:=DoW(JD,t_UT,_English);
 writeln(yyyy,'-',mm:2,'-',nd:2,'  at ',h_min_s(Bas_Int(UT+t_UT,24)),
   '  (',Name,')',cl+
   ' expressed in the used time, which is ',t_UT:4:1,' h ahead of th UTC');
 yyo:=yyyy-1; mmo:=mm-1; ndo:=nd-1;

 WRITELN('Julian date  : ',JD:13:4,cl);

 write(he0);
 if t_UT>0 then write('+',t_UT:4:1)
 else write('-',-t_UT:4:1);
 if Kind=1 then
  write(he11,he61,he91)
 else
  begin
   write(he1[Kind]);
   if faint_abs>-20 then write(he2f);
   write(he3);
   if Kind=4 then write(he4h)
   else write(he4);
   if (kind>3) and (faint_abs>-20) then write(he5fp);
   if Kind=4 then write(he6h) else write(he6);
   if faint_abs>-20 then
    begin write(he7f); if Kind>3 then write(he7fp) else write(he7fm) end;
   write(he8);
   if faint_abs<=-20 then
    if Kind=4 then write(he9h) else write(he9)
   else
    begin
     if Kind=4 then write(he9hf) else write(he9f);
     if Kind>3 then write(he10fp) else write(he10fm);
     write(he10);
    end;
  end;
 write(cl2);

 eph_time:=MJD;
 for j:=0 to Next do
  begin
   Planet_hel(3,eph_time+jd_MJD+tt_ut,l,b,rG,Name);
   ls:=bas_int(l+180,360);
   object_hel(
    semiaxis_large,
    perihel_dist,
    excentricity,
    inclin,
    asc_node,
    perih_from_asc_node,
    perih_pass,
    eph_time,
    xe,ye,ze,r);
   raux:=r;
   c3_to_Pd(xe,ye,ze,raux,l,b);
   Name:=copy(DoW(eph_time+JD_MJD,t_UT,_English),1,3);
   if kind=4 then time:=copy(time,1,5);
   time:=' '+time+' ';
   if yyyy=yyo then
    if mm=mmo then
     if nd=ndo then
      write('              ',time)
     else
      write('        ',nd:2,' ',Name,time)
    else
     write('    -',mm:2,'-',nd:2,' ',Name,time)
   else
     write(yyyy,'-',mm:2,'-',nd:2,' ',Name,time);
   yyo:=yyyy; mmo:=mm; ndo:=nd;
   if Kind=1 then
    writeln(l:8:3,' = '+deg_to_HM(l),', ',b:7:3,' = '+deg_to_dm(b),r:6:2)
   else
    begin
     Hel_to_Geo(eph_time+JD_MJD+tt_ut,l,b,r,lg,bg,rg);
     o_ph_a:=object_phase_angleD(l,b,lg,bg);
     faintness:=planet_faintness(1,o_ph_a,r,rg);
     if Kind=2 then
      begin
       l:=lg;
       b:=bg;
      end
     else
      begin
       LB_RD(lg,bg,l,b);
       if Kind>3 then
        begin
         RA:=l;
         A_h_PA(SM,RA,b,l,h,bg,Air_mass) ;
         if Kind=4 then
          b:=h
         else
          l:=Bas_Int(360*SM/24-l,360)
        end;
      end;
     if Kind<>4 then
      write(l:7:3,'= '+deg_to_HM(l),'  ',b:7:3,'='+deg_to_dm(b),
             rg:6:2,Bas_Int(lg-ls+180,360)-180:5:0)
     else
      begin
       LB_RD(ls,0,lg,bg);
       write(l:7:2,' = '+deg_to_HM(l),'  ',b:6:2,' ='+deg_to_dm(b),
             rg:6:2,Bas_Int(RA-lg+180,360)-180:5:0)
      end;
     if Faint_abs>-20 then
      begin
       if Comet then
        faintness:=Faint_abs+2.5*Comet_exponent*ln(r)/l10+5*ln(rg)/l10
       else
        faintness:=Faint_abs+2.5*             2*ln(r)/l10+5*ln(rg)/l10
                   +faintness+0.42{absolute faintness of Mercury};
       write(faintness:5:1);
       if Air_mass>0 then
        write(Air_mass*Zenith_ext:5:1)
       else if Kind>4 then write('     ') else write('   ');
      end
     else write('  ');
     writeln(o_ph_a:4:0);
    end;
   if Morning_or_evening=' ' then
    begin
     eph_time:=eph_time+step;
     SM:=bas_int(SM+24.0657098230*step,24)
    end
   else
    begin
     if Kind=4 then
       Is_Moon_there;
     if morning_or_evening='B' then
      if MoE='M' then
       MoE:='E'
      else
       begin
        eph_time:=eph_time+step;
        MoE:='M'
       end
     else
      eph_time:=eph_time+step;
     if not At_height(MoE,-Sun_depth,eph_time) then halt;
     JD:=eph_time+JD_MJD;
     Name:=DoW(JD,t_UT,_English);
     DD:=ND;
     Get_JD;
    end;
  end;
 if Explanation then
  if Kind=1 then
   writeln(cl+
'   (column  >far<  gives distance of the body from the Sun)')
  else
   begin
    writeln('Column:',cl,
'  > far <  gives distance of the body from the Earth,');
    if kind=2 then writeln(
'  >long.-_Sun< is the difference of the ecliptical longitude of the body')
    else writeln(
'  >RA-_Sun< is the difference of the right ascension of the body');
    writeln(
'          from that of the Sun (if positive, the body is east from the Sun),');
    if Faint_abs>-20 then
     begin
      write(
'  >faint<  says how faint would the object be assuming',cl,
'          that at 1 AU from both Earth and Sun it would be faint', Faint_abs:5:1,' mag',cl,
'          and ');
      if Comet then
       writeln('its "cometary exponent" would be',Comet_exponent:4:1,',')
      else
       writeln(
              'that phase angle would affect it like in case of Mercury,');
      if Kind>3 then writeln(
'  >   + <  says how fainter it would appear due to atmospheric exctiction',cl,
'          assuming extinction in zenith being',Zenith_ext:5:1,' mag,');
     end;
    writeln(
'  > PhAn<  is the "phase angle", i.e., angle Sun-body-Earth.');
   end;
end.
