 {~ Equatorial coord. of a star: original frame (B1950) --> new frame (J2000)~}

program preces;

uses precesse, str_num;

const
h1=cl+
'Preces { <RA/1degree>|<hh:mm:ss.hs> } { <Decl/1degree>|dd:mm:"" }'+cl+
'          [<Year_ori> [<Year_new>]]'+cl+cl+

'transforms equatorial coordinates of a fixed star from the <Year_ori>'+cl+
'to the <Year_new> frame (from "equinox Year_ori" to "equinox Year_new").'+cl;
h2=
'Default <Year_ori> is 1950.0 (Bessel epoch, approximat. 12 h UTC of Jan 1-st),'+cl+
'default <Year_new> is 2000.0 (Julian date 2 451 545.0 = 12 h UTC of Jan 1-st).'+cl2;
h3=
'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999,'+cl+
' using a precession module by Petr Pravec, Astronomical Institute, Ondrejov;'+cl;
h4=
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'+cl;

Year_ori:real=1950.0;
Year_new:real=2000.0;

var RA,Decl:real; j:integer; hh,mi,ss,hs:word;

 procedure Help;
  begin
   write(h1,h2,h3,h4);
   halt
  end;

begin
if paramcount<2 then help;
val(paramstr(1),RA,j);
 if j>0 then
  if BabS2Dec(paramstr(1),hh,mi,ss,hs,RA,'H') then
   RA:=RA*15
  else help;
val(paramstr(2),Decl,j);
if j>0 then
 if not BabS2Dec(paramstr(2),hh,mi,ss,hs,Decl,'D') then help;
if paramcount>2 then
 val(paramstr(3),Year_ori,j);
if paramcount>3 then
 val(paramstr(4),Year_new,j);
if PrecInit(Year_ori,Year_new) then
   Precess(RA,Decl);
writeln(RA:8:4,Decl:9:4,'  are J',Year_new:6:1,' RA and Declination / 1 degree'+cl+
        '         from those of J',Year_ori:6:1)
end.
