 {~ Height of the Sun, added to the end of the lines, to stand. output ~}


PROGRAM sol_hei;
    {adapted by Jan Hollan from Tomas Rezek's program SUN_BY_NAKED_EYES;}
(*  Copyright (C) 1999 Jan Hollan

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)

uses dos,
     str_num,angles_o,Solar_ut,planets,params;
VAR
 T,LambS,aux_r: REAL; aux_s, line, InpTF:string;
 j:byte;
 inpf: text;
 

procedure Help;
begin
 WRITE(cl,
 'Program by Jan Hollan, Obs. and Planetarium in Brno, 2004,',cl,
 ' (subject to the GNU General Public License, http://www.gnu.org/copyleft , ',cl,
 '  source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'+cl2,

 'writes Azimuth and Height of the Sun at the end of the line of the'+cl+
 ' standard output, when the first item on the line of the input file is JD',cl2,

 'sol_hei <input text file> dDD[.MM[.YYYY]] tHH[:MM[:SS] UT# l<longitude> f<latitude>',cl2,

 'D and T: initial values are taken from the system date and time,',cl,
 'UT is the t-UTC difference / 1 h (default 1 from Nov. to March, else 2)'+cl+
 'longitude and latitude (/ 1 degree) are initially those of '
  +MyLocation_Name+'.',cl2,
  '(Just to correct the AirMass:)',cl,h_refraction);
 halt
end;

BEGIN
if paramcount>0 then for j:= 1 to paramcount do
 begin
  Par:=paramstr(j);
  if Par[1] in ['/','-'] then 
   begin Par:=copy(Par,2,length(par)-1);
   case UpCase(Par[1]) of
    '?','-': Help; {- added to respect unix --help even without the help}
    'D' : if not Par_date then help;
    'T' : if not Par_time_or_TT then help;
    'U' : if not Par_UT then help;
    'L' : if not Par_Lambda then help;
    'F' : if not Par_Fi then help;
   end; {of case}
  end
  else
    InpTF:=Par;
 end {of for}
else 
 help;

if not rt_reset('',inpf,InpTF) then halt;

repeat
 readln(Inpf,line);
 JD:=R_S(ItemStr(1,line));
 
{Get_JD;}
if not tt_UT_set then tt_ut:=tt_UTC_in_days(JD);
SM:=Get_SM(JD,lambda);
Planet_hel(3,jd+tt_UT,LambS,T,aux_r,aux_s);
LambS:=bas_int(LambS+180,360);
  {LambS:=Sun_long(JD);} {this had rather low precision}
Ecl_to_Equ(LambS,RA,Decl);
T:=Bas_int(SM-(RA/15),24);
A_h_PA(SM,RA,Decl, A,h,PA,Air_mass);

writeln(line, A:6:1, h:6:1);

until eof(Inpf);

close(inpf)

END.
