#set term vgamono
set title 'Air mass'
set xlabel 'angular height / 1 degree'
#cotg(x)=tan((90-x)*pi/180)
#refr(x)=1000*(60.236-0.070*(cotg(x)**2))*cotg(x)/3600  # acc. to Jan Vondrak
#n=1.0002917
#plrf(x)=1000*(180*acos(cos(x*pi/180)/n)/pi - x)  # as if a plane surface
#pol(x)= 5.0528E+02 + x*(-1.5278E+02 + x*( 2.9775E+01 + x*(-3.3643E+00 + x*( 1.6082E-01))))
#plot [0 to 30] [0 to 500] "refrac.txt" using 5:4, pol(x), refr(x), plrf(x)

# the definition below is by Kristensen, L. K. (1998), 
# Astronomische Nachrichten, 319, 193. It might be perhaps better below 
# horizon than the formula I use, 1/(si(x)+0.025*exp(-11*si(x))). 
# But as regards extinction, it is always large there because of the 
# aerosols being mostly in the bottom kilometres, so the 
# ``effective'' AM rises more with decreasing angular height than the true AM.

 z(x) = (90 - x)*pi/180
 b(x)=462.46 + 2.8121/(cos(z(x))**2 + 0.22*cos(z(x)) +0.01)
 A(x)=sqrt((b(z(x))*cos(z(x)))**2 + 2*b(z(x)) + 1) - b(z(x))*cos(z(x))


si(x)=sin(x*pi/180)
s(x)=(1/sin(x*pi/180))-1
mi(x)= s(x)+1-0.00186*s(x)-0.002875*s(x)**2-0.0008083*s(x)**3 # Astr.prir.    
plot [-0.57 to 15] [0 to 45] 1.014/(0.014 + sin(x*pi/180)), 34.8+(2-8*x),\
 mi(x), 19.8+(2-8*x), 1/(si(x)+0.025*exp(-11*si(x))), 1/si(x), \
 A(x), "am.txt"
