{~ replaces spaces by &nbsp, after specified one-letter prepositions ~}
{~ or by ~ (default) (a slight modification of Vlnka.pas, offered by CSTUG) ~}

{in half-Czech, from Vlnka.pas available in CSTeX distribution
                                          by Czech and Slovak TeX user group}

 { Has to be converted to the appropriate code page,
   as it conversates in Czech with diacritics;
   the original code page is 'Kamenicky'}

{
Vlnku puvodne napsal  RNDr. Oldrich Ulrych.  Bylo pro mne uzitecn si puvodn
program precst, ale pak jsem jej napsal tmer cely znovu.
                                                  Stepn Kasal, MFF UK Praha
PS.
Muj program je ovsem strasne zbastlen -- nikomu neradm jej modifikovat!
To to radeji napiste znova -- treba v Ccku.            kasal@cspguk11.bitnet
}

{Mkk konce dk v soubeorech CSEDu, defaultn striktn pravidlo i pro
 jednopsmenn spojky, .ltx misto .tex, vynechan dotaz na mnoinu pedloek,
 alternativa &nbsp; a chr(254) msto ~, help po standardnm ? -h --help...
 --- upravil si Jenik Hollan, hollan@ped.muni.cz}

{$A-,B-,D-,E+,F-,G-,I+,L+,N+,O-,R+,S-,V+,X-}

program vlnka;
uses dos;

const pre='([`"}{';                                       verze='1.04';
      cl=#13#10;
      h1=cl+
'Vlnka <jmno souboru> [[h|6]mnoina 1-ps. pedloek a spojek]'+cl+cl+

'Program Vlnka dopluje ,,tvrdou mezeru`` za jednopsmenn pedloky'+cl+
'a spojky. Standardn jejich mnoinou jsou vechny: KkSsVvZzAaUuIiOo,'+cl+
'standardn tvrdou mezerou je znak ~ (tilda).'+cl+cl;
      h2=
'Zan-li druh parametr znakem h, tvrd mezera (no_break_space)'+cl+
'se zape jako &nbsp; -- to je pro texty v html.'+cl+
'Zan-li slem 6, msto ~ se uv znak s kdem 254 (FE)'+cl+
'(to je pro texty v editoru T602 ped jejich konverz do jinch formt).'+cl+cl;
      h3=
',,Vlnkovn`` lze ve zdrojovm textu vypnout sekvenc %~-' +cl+
'a pak zase zapnout sekvenc %~+ .'+cl;
      h4=cl+
'( Program . Kasala napsan dle O. Ulrycha pro CSTUG jemn doplnil J. Hollan'+cl+
' zdrojov text je na http://astro.sci.muni.cz/pub/hollan/programmes)'+cl;

      crlf=chr(14)+   {added: soft return of CSED files}
           chr(13)+chr(10); space_wout_crlf=' '+chr(9);
      space=space_wout_crlf+crlf;
      endline = crlf; { je-li nutno vlozit konec radky }
      rett='vlnka_$#.~_~'; { to bude stacit -- a da se poznat, co to je }
      predldef='KkSsVvZzAaUuIiOo'; { po A je to minimum
       (Je-li "a", "i", "o" ci "u" na konci radky, neni to gramaticka chyba.) }

      hardspacetex:char='~';
      hardspacehtml:string[6]='&nbsp;';
      hardspace602:string[1]=chr(254);
      hardspace:string[6]='~';

    buf:string='';
    nrad:Boolean=true;
    line:Boolean=false;

var znak:char;
    reta,predl:string[63];
    Lpredl:char;{predl[0]}
    fi,fo:text;
    dir:dirstr;
    name:namestr;
    ext:extstr;
    aux_s:string[18];

procedure help;
begin
 write(h1,h2,h3,h4); halt;
end;


procedure uvod;

begin

writeln(cl+'Doplnn vlnek za pedloky (verze '+verze+')');
if paramcount<1 then
    begin
     writeln;
     write('Nzev souboru  (.ltx) : ');  readln(reta);
    end
else reta:=paramstr(1);

if (reta='-h') or (reta='--h') or (reta='--help') or (pos('?',reta)>0) then
 help;


fsplit(reta,dir,name,ext);
if ext='' then reta:=dir+name+'.ltx';
reta:=FSearch(reta,'');
if reta='' then help;
assign(fi,reta);  reset(fi);
assign(fo,dir+rett);  rewrite(fo);
if paramcount<2 then
  begin
   { predl:=GetEnv('VLNKA');
    if length(predl)=0 then
      begin
      write('Pedloky ( <Enter> = '+predldef+' ) : ');  readln(predl);
      if length(predl)=0 then
    }   predl:=predldef;
    {  end
    }
  end
else
 begin
  aux_s:=paramstr(2);
  if aux_s[1] in ['h','6'] then
   begin
    if aux_s[1]='h' then hardspace:=hardspacehtml
    else hardspace:=hardspace602;
    aux_s:=copy(aux_s,2,length(aux_s)-1);
    if aux_s='' then aux_s:=predldef;
   end;
  predl:=aux_s;
 end;
Lpredl:=predl[0]

end;             { UVOD }



procedure konec;
begin
  if not nrad and line then writeln(fo);
  write(fo,buf);
  close(fi);  close(fo);
  erase(fi);
  rename(fo,reta);
  halt
end;             { KONEC }



procedure cti;
begin
  if not eof(fi) then read(fi, znak)
  else konec
end;          { cti }


procedure pisacti;
begin
  write(fo,znak);
  if not eof(fi) then read(fi, znak)
  else konec
end;          { pis a cti }


function v(s:string):Boolean;
begin  v:=(pos(znak,s)>0)
end;         { v }


function jetamlf:Boolean;
var oldznak:char;
begin
  oldznak:=znak;
  cti;
  jetamlf := v(crlf) and not(oldznak=znak)
end;


procedure skipcomment;
begin
  while znak='%' do pisacti;
  while v(space_wout_crlf) do pisacti;
  if znak='~' then
    begin
      pisacti;
      while v(space_wout_crlf) do pisacti;
      case znak of
        '+': predl[0]:=Lpredl;
        '-': predl[0]:=#0
      end
    end;
  while not v(crlf) do pisacti;
  write(fo,znak); if jetamlf then pisacti;
  nrad:=true
end;         { skip comment }


procedure opismezery;
begin
  while v(space) or (znak='%') do
    if znak='%' then skipcomment
    else
      begin
        nrad:=nrad or v(crlf); pisacti
      end
end;           { opismezery }


procedure opisdomezery;
var bylbackslash:Boolean;
begin
  bylbackslash:=false;
  while not v(space) and ( (znak<>'%') or bylbackslash ) do
      begin
        bylbackslash:=(znak='\');
        pisacti
      end;
  if (znak='%') and not bylbackslash then skipcomment
end;           { opisdomezery }



function predlozka:Boolean;

  function par: Boolean;
  var konec,lline:Boolean;
  begin
    par:=false; konec:=false; lline:=false;
    while v(space) and not konec do
      if v(crlf) then
        if lline then begin par:=true; konec:=true
                      end
        else
          begin
            if jetamlf then cti;
            lline:=true
          end
      else cti;  { end while }
    if  znak='%' then par:=lline
    else line:= line or (lline and  not konec)
  end; { par }

begin
  predlozka:=false;
  while v(pre) do begin buf:=buf+znak; cti
                  end;
  if v(predl) then
    begin
      buf:=buf+znak; cti;
      if v(space) then
        if par then buf:=buf+endline
          else if znak='%' then buf:=buf+' '
                 else
                   begin buf:=buf+hardspace; predlozka:=true
                   end
    end
end;     { predlozka }



begin        { MAIN }
uvod;
cti;
repeat
  opismezery;
  while predlozka do;
  if not nrad and line then writeln(fo);
  write(fo,buf); nrad:=false; line:=false; buf:='';
  opisdomezery
until false
end.          { MAIN }



Tohle je puvodni verze Dra Ulrycha:

program vlnka;
uses dos;

const mez=' ';   zcr=chr(13);   zlf=chr(10);  rett='10#2$D79.3#R';
var last,znak:char;
    ret,reta:string;
    line,nrad:boolean;
    fi,fo:text;
    prep:integer;
    predl:string;
    dir:dirstr;
    name:namestr;
    ext:extstr;

begin;
writeln('Doplneni vlnek za predlozky');
if paramcount<1 then
  begin;
  write('Nazev souboru           : ');  readln(reta);
  end
else reta:=paramstr(1);
fsplit(reta,dir,name,ext);
assign(fi,reta);  reset(fi);
assign(fo,dir+rett);  rewrite(fo);
if paramcount<2 then
  begin;
  write('Predlozky ( <CR> = KkOoSsUuVvZz ) : ');  readln(predl);
  if length(predl)=0 then predl:='KkOoSsUuVvZz';
  end
else predl:=paramstr(2);
ret:=mez+zcr+zlf;
prep:=0;  nrad:=true;  line:=false;
while not eof(fi) do
  begin;  read(fi,znak);
  case prep of
    0:begin;
      if pos(znak,ret)=0 then
        begin;  last:=znak;  prep:=1;  end
      else
        begin;  write(fo,znak);
        if znak=zcr then
          begin;  write(fo,zlf); read(fi,znak);  nrad:=true; line:=false;  end;
        end;
      end;
    1:begin;
      if pos(znak,ret)=0 then
        begin;  prep:=2;  write(fo,last+znak);  nrad:=false;  line:=false;  end
      else
        if pos(last,predl)>0 then
          begin; prep:=3;
          if znak=zcr then line:=true;
          end
        else
          begin; prep:=0;
          write(fo,last+znak);                   line:=false;
          if znak=zcr then
            begin;  nrad:=true;  write(fo,zlf);  read(fi,znak);  end;
          end;
      end;
    2:begin;
      write(fo,znak);
      if pos(znak,ret)>0 then prep:=0;
      if znak=zcr then
        begin;
        write(fo,zlf);  read(fi,znak);
        nrad:=true;
        end;
      end;
    3:begin;
      if pos(znak,ret)>0 then
        begin;
        if znak=zcr then line:=true;
        end
      else
        begin;
        if (not nrad)and line then
          begin;  writeln(fo);  nrad:=true;  end;
        write(fo,last+hardspace);
        last:=znak;  prep:=1;
        end;
      end;
    end;
  end;
close(fi);  close(fo);
erase(fi);
rename(fo,reta);
end.
