 {~ Setting video modes of VGA cards (standard, VESA 6a, card-specific ones). ~}
 {~ A crazy screen can be often cured by: VMod 3 ~}

program VMod; {by Jan Hollan, when learning video cards switching
  - setting VGA modes (standard, VESA 6a, or card-dependent extended ones)}

uses Dos,hdconv;
const cl=#13#10;
var
  reg : registers; j:integer;
  i, L: byte;
  Deci : longint;
  HexS : string[2];
  HexB : array [0..2] of byte absolute HexS;
  Pow : longint;

begin
if ParamCount=1 then
 begin
  if pos('?',paramstr(1))>0 then
   begin
    writeln(cl,
'vmod [#]',cl,
cl,
'says or sets the standard (or VESA 6a) videomode. # is to be hexadecimal.',cl,
cl,
'(source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'
);
    halt;
   end;
     Deci:= 0; Pow:=1;
     HexS:=ParamStr(1);
     L:= HexB[0]+1;
     for  i:= 1 to HexB[0] do
      begin
       if (HexB[L-i]<59) and (HexB[L-i]>47) then
          inc(Deci,(HexB[L-i]-48)*Pow)
       else
          if (HexB[L-i]<71) and (HexB[L-i]>64)  then
           inc(Deci,(HexB[L-i]-55)*Pow)
          else
           if (HexB[L-i]>96) and (HexB[L-i]<103) then
            inc(Deci,(HexB[L-i]-87)*Pow)
           else
            begin
             writeln(
'A hexadecimal number of wanted video mode needed -- ',HexS,' is no such number.');
             halt
            end;
       inc(Pow,15)
      end;
  reg.ah := 0;
  reg.al := Deci;
  intr ($10, reg);
  reg.ah := $0f;
  intr ($10, reg);
  write(cl,cl,cl,cl,cl,cl,cl);
  if reg.al=Deci then
   if Deci<=$13 then
    Writeln('Video Graphics Array mode $',HexS,' =',Deci:3,' has been set.')
   else
    if Deci=$6a then
     Writeln('VESA video mode $',HexS,' =',Deci:3,' has been set.')
    else
     Writeln('SVGA mode $',HexS,' =',Deci:3,' (HW-dependent) has been set.')
  else
     Writeln('Video mode $',HexS,' =',Deci:3,' is not supported by the card.');
  Writeln('Number of columns of the screen: ',reg.ah);
  Writeln('Number of an actual screen page: ',reg.bh);
 end
else
 begin
  reg.ah := $0f;
  intr ($10, reg);
  Deci:=reg.al;
  if Deci<=$13 then
   Writeln('Video Graphics Array mode $',DecToHexP(Deci),' =',Deci:3,' holds now.')
  else
   if Deci=$6a then
    Writeln('VESA video mode $',DecToHexP(Deci),' =',Deci:3,' holds now.')
   else
    Writeln('SVGA mode $',DecToHexP(Deci),' =',Deci:3,' (HW-dependent) holds now.');
  Writeln('Number of columns of the screen: ',reg.ah);
  Writeln('Number of an actual screen page: ',reg.bh);
 end

end.
