{~ shows wedge of grays and some sets of stars (smooth and ordinary circles) ~}

program wedge16; {by Jan Hollan: showing a wedge of 15 grays}

uses Graph,DOS,str_num,un_str_m,crt,graph_m8;


var  i,j:longint; m,k,Sradius:byte; x,y:word;
      rr:word;
    ps: array[1..80] of pointer; p_heap:pointer;
    par:string[10];

 procedure help;
 begin
  writeln(cl,
'wedge16 [SVGA[#][:#]]',cl2,

'shows a wedge of 15 and all available grays, and some sets of circles',cl,
' (representing stars in maps of the sky). The only parameter is:',cl,

'SVGA#    or',cl,
'SVGA256:# Try SVGA 256-color mode # (default 4 for the 1024x768 resolution',cl,
'                                3 would set the 800x600 mode)'+cl+
'SVGA16:# is an 16 color alternative for 0.5 MB cards'+cl+
'SVGA:#   is another 256-color alternative, if you have just svga.bgi',cl,
'   -- caution, some cards lock up the computer and just RESET button helps');
   halt;
  end;

procedure screen_star(x,y,radius:word);
 var i,j:word; rs,rs2:byte; gray:integer; aux_r:real;
    ULX,ULY,LRX,LRY:integer; SiFig: word;

 begin
  if radius>80 then radius:=80;
  rs:=(radius+7) div 16;
  rs2:= {(radius+7) div 8} rs+1;
  if ps[radius]=nil then
   begin
    gray:=(radius*MaxColorD16) div 2 + MaxColorH;
    if gray>MaxColor then gray:=MaxColor;
    putpixel(x,y,gray);
    if rs2>0 then
     begin
      for i:=1 to rs2 do
       for j:=0 to rs2 do
        begin
         gray:=RoundUp(MaxColorD16*(7+radius-sqrt(sqr(16*i)+sqr(16*j))));
         {if (rs<2)
         or (gray>0) then} gray:=gray div 2 + MaxColorH;
         if gray>MaxColor then gray:=MaxColor;
         if gray>0 then
          if j=0 then
           begin
            putpixel(x+i,y,gray);
            putpixel(x-i,y,gray);
            putpixel(x,y+i,gray);
            putpixel(x,y-i,gray);
           end
          else
           begin
            putpixel(x+i,y+j,gray);
            putpixel(x-i,y+j,gray);
            putpixel(x-i,y-j,gray);
            putpixel(x+i,y-j,gray);
            if i<>j then
             begin
              putpixel(x+j,y+i,gray);
              putpixel(x+j,y-i,gray);
              putpixel(x-j,y-i,gray);
              putpixel(x-j,y+i,gray);
             end
           end;
        end;
     end;
    ULX:=x-rs2; ULY:=y-rs2; LRX:=x+rs2; LRY:=y+rs2;
    SiFig:= ImageSize(ULX,ULY,LRX,LRY);
    if SiFig<MaxAvail then
     begin
      GetMem(ps[radius],SiFig);
      GetImage(ULX,ULY,LRX,LRY,ps[radius]^)
     end
    else
     halt;
   end
  else
   PutImage(x-rs,y-rs,ps[radius]^, NormalPut);
 end;

function inside(xi,yi:word):boolean;
 begin
  if  (0<xi) and (xi<getmaxx)
  and (0<yi) and (yi<getmaxy)
  then
   begin
    inside:=true;
    x:=xi;
    y:=yi;
   end
  else
   inside:=false;
 end;

begin
 if paramcount>0 then
  begin
   par:=__cvtstr(paramstr(1),_to_upcase_str);
   if pos('?',par)>0 then help;
   if length(par)>3 then
     if copy(par,1,4)='SVGA' then
      begin
       if ItemCountD(':',par)>1 then
        begin
         SVGAmode:=I_S(ItemStrD(':',2,par));
         SVGA_driverName:=ItemStrD(':',1,par);
        end
       else
        if length(par)=5 then
         SVGAmode:=ss2i(par,5)
        else
         SVGA_driverName:=par;
       SVGA:=true;
      end;
  end;
 gm_init(100,100);
 setcolor(MaxColor);
 outtextxy(20,20,'A wedge of 15 and available grays (press any key to exit)');

 j:=(31*15) div MaxColor;

 for i:=0 to 15 do
  for m:=0 to 30 do
   for k:=0 to 50 do if inside(31+31*i+m,35+k) then
    putpixel(x,y,MaxColorD16*i);
 for i:=0 to MaxColor do
  for m:=0 to (30*15) div MaxColor do
   for k:=0 to 50 do if inside(31+j*i+m,86+k) then
    putpixel(x,y,i);

 for rr:=1 to 80 do ps[rr]:=nil;

setcolor(MaxColor);
setfillstyle(solidfill,getColor);

 if GetMaxX>480 then
  begin
   outtextxy(480,150,'Standard circles');

   for i:= 0 to 7 do         {empty circles}
    for j:= 1 to 10 do
     circle(450+j*16,320+i*16,(j+10*i) div 16);

   for i:= 0 to 7 do
    for j:= 1 to 10 do          {should be full circles}
     begin
      circle(450+j*16,170+i*16,(j+10*i) div 16);
      floodfill(450+j*16,170+i*16,MaxColor);  {failed in some ver. of fpk}
     end;
  end;
mark(p_heap);
setcolor(MaxColor);

 outtextxy(80,150,'Stars by wedge16');

 for i:= 0 to 7 do           {stars by the above procedure}
  for j:= 1 to 10 do
   if inside(50+j*16,170+i*16) then
    begin
     Sradius:=j+10*i;
     screen_star(x,y,Sradius);
    end;

release(p_heap);
setcolor(MaxColor);

 outtextxy(280,150,'Stars by graph_m8');

 for i:= 0 to 7 do           {stars by graph_m8}
  for j:= 1 to 10 do
   if inside(250+j*16,170+i*16) then
    gm_star(16*x,16*y,j+10*i,j+10*i,0,false,'');

 for i:= 0 to 7 do    {variable stars in maximum brightness, by graph_m8}
  for j:= 1 to 10 do
   if inside(250+j*16,320+i*16) then
    gm_star(16*x,16*y,j+10*i,j+10*i,0,true,'');


 repeat until keypressed;
closegraph;

end.
