 {~ Controls printers using Epson language, in Czech ~}

program SetLpt;  {zen tiskrny v mdu Epson
                   verze 1.0, 93-03-09 Jan Hollan.}
uses printer;
var i : byte;
const Esc: char = char(27);
      Left: boolean = False;

Procedure Vysvetlivky;
begin
 writeln('Program SetLpt nastavuje tiskrnu (Lpt1 i Prn) v mdu Epson.');
 writeln(' Parametry odddlen mezerami se p za sebou na pkazov dek:');
 writeln('   i - Inicializovat (suspendovat DownLoad, zruit SW-volbu psma');
 writeln('       a ve ostatn, jen textov "buffer" se nevyprzdn),');
 writeln('   1. slo - lev okraj,');
 writeln('   2. slo - prav okraj.');
 writeln('   c - centrovat,');
 writeln('   r - zarovnat vpravo,');
 writeln('   l - zarovnat vlevo (jako obvykle),');
 writeln('   b - zarovnat na obou krajch.');
 writeln('   h - hust dkovat (8 dk na palec; T602 jej per)');
 writeln('   e - Elite (12 CpI) ');
 writeln('   m - 15 CpI         ');
 writeln('   p - Proportional   ');
 writeln('   z - Condens        ');
 writeln('   t - Tun          ');
 writeln('   d - Dvojit        ');
 writeln(
 '   ~ - Escape - nsleduje Esc-sekvence (bez mezer); slo umstn mezi rkami' );
 writeln(
 '                se pole jako znak s tmto kdem - to se hod u kd < 33;');
 writeln(
 '                pehled Esc-sekvenc viz soubor EscF.txt i Esc*.txt.');
 writeln('   ( - slovo za n se pole beze zmn (ope se)');
 writeln(
 'Na poad parametr nesejde (jen prav okraj je nutno zadat a po levm).');
 writeln(
'(Jan Hollan, 1993, zdroj viz http://astro.sci.muni.cz/pub/hollan/programmes)');
 halt
end;

procedure Pokyn(i:byte);
var code: integer;
    n, p: byte;
    Parameter: string[20];
    LenPar: byte absolute Parameter;
    OutPar: string[10];
    z: char;
begin
 Parameter:=ParamStr(i);
 Val(ParamStr(i),N,code);
 if (Code>0) then
  begin
    n:=255;
    case Parameter[1] of
       'c','C' :     begin z:= 'a'; n:=1 end;            {centering}
       'r','R','Q' : begin z:= 'a'; n:=2 end;    {to the right rim}
       'l','L' :     begin z:= 'a'; n:=0 end;
       'b','B' :     begin z:= 'a'; n:=3 end;
       '/','?' :     Vysvetlivky;
       'i','I','@' : z:='@';      {Initialisation}
       'h','H' :     z:='O';      {8 RpI}
       'e','E' :     z:='M';      {Elite}
       'm','M' :     z:='g';      {15 CpI}
       'p','P' :     begin z:='p'; n:=1 end;    {Proportional}
       'z','Z' :     z:=char(15); {Condens}
       't','T' :     z:='E';      {Tun}
       'd','D' :     z:='G';      {Dvojit}
       '('     :begin write(lst,copy(Parameter,2,LenPar-1)); exit end;  {Text}
       '~'     :begin        {Escape sequence}
                 OutPar:=Esc;  Parameter:= copy(parameter,2,LenPar-1);
                 repeat
                 if Parameter[1] = ',' then  {number to be converted in byte}
                   begin Parameter:=copy(Parameter,2,LenPar-1);
                         p:= Pos(',',Parameter);
                         if p>4 then
                            begin 
                          writeln('slo ',copy(Parameter,1,p-1),' pedlouh!');
                          exit
                            end;
                         Val(copy(Parameter,1,p-1),n,code);
                         if (Code>0) then
                            begin 
                            writeln('to nen slo: ',copy(Parameter,1,p-1));
                            exit end
                         else
                            begin if n>255 then
                                    begin
                                    writeln('slo ',n,' > 255!'); exit end;
                                  OutPar:= OutPar+char(n);
                            end;
                         Parameter:= copy(Parameter,p+1,LenPar-p)
                   end
                 else {character}
                   begin OutPar:= OutPar + Parameter[1];
                         Parameter:= copy(Parameter,2,LenPar-1)
                   end;
                 until LenPar<1;
                 write(lst,OutPar);
                 exit
                end;
       else begin writeln('neznm parametr: ',Parameter); exit end
    end;
    if n<255 then write(lst,Esc+z+char(n)) else write (lst,Esc+z);
  end
 else
  begin
    if Left then Z:='Q' else begin Z:='l'; Left:=True end;
       write(lst,Esc+Z+char(N))
  end;
end;

begin
  if ParamCount>0 then
    for i:= 1 to ParamCount do Pokyn(i)
   else
    Vysvetlivky
end.
