program TiskComp ; {Mixed text and graphic print
                          FROM  the simplest print-to-a-file output of T602
                          TO    the CS212-25  printer.
                    144 DpI graphics,  with Condens printed at 20.6 CpI.

                   Jan Hollan,  Obs. and Planetarium,  616 00  Brno.

      Broad and Large characters are made more smooth, than in T602.
      The character Pt is printed as a symbol of partial derivation
        (see the beginning of the main program).                         }

{version 1994-03-07:
       character #17 (Ctrl+P,1 in T602) switches on/off using italics,
                 #18 (Ctrl+P,2 in T602) switches using indices fonts. }

{poznmky 1993-05:
Pro zrychlen tisku z XT by bolo mono tisk znaku write(lst,c) nahradit
pipsnm k vstupnmu etezci Swrite(c) a ten pak vytisknout,
a je pln, i a nic jinho nezbv. Vstupn soubor vlastn nen textov
- nejsou v nm dvojice EOL, neb svisl posuv se dociluje jen uitm znaku
130 v reimu 144 DpI, tj. posunem o grafick dek 4"/72, v potebnm potu.

Jak se na to dvm, Condens by se neml nejprve vytvet setenm kadch dvou
po sob nsledujcch sloupc, a pak ppadn pi volb "144" zase roziovat,
neb se tak ztrc informace. Pi volb "144" by se "Cond" pase mly ve vo-
dorovnm smru zachovat beze zmny.}

uses Fon25 {unit with fonts for the printer} , Printer, crt, DOS;
const
  Spaces : byte= 0; {number of leading spaces}
  GS     : char= #128; {graphic sequence start - 144 DpI}
  ThBL   : boolean = False;
  Negative:boolean = False;
  G144   : boolean = False;
  AllGr  : boolean = False;
  LQ     : boolean = False;
  G72    : boolean = False;
  NoStart: boolean = False;
  UnderLine: boolean=False;
  Cond   : boolean = False;
  SCond  : boolean = False;
  Pica   : boolean = False;
  Open   : boolean = False;  {Is the input file Opened?}
  WasStandard: boolean=False;
  Page   : byte = 1;
  W      : byte =12; {Width of a letter - number of columns}
  SwGS   : boolean= False;
  SQ     : byte = 0;       {Mode of writing; 0 - standard letters}
  Shift  : byte = 0;    {5: 6 lines per inch, 6: 4 lines, 7: 3 lines per inch}
  OldShift:string[6]= #130#130#130;
                      {sequence for another LpI to be sent to the printer}
  Zeros  : array [1..12] of char = #0#0#0#0#0#0#0#0#0#0#0#0;
  SinglePages: boolean=False;   {No Prompt after each page}
  HL     : boolean = False;     {Initilisation of High Letters to No}
  Italic_font: boolean=false;
  Indices_font: boolean=false;
  NewPage: boolean =false;

  BS: array [1..8] of byte = (1,2,4,8,16,32,64,128);
  ParamAr: array[1..13] of string[4] = ('SP','COND','LEFT','PAGE','PICA',
                        'GR', 'LQ', '72', '144', 'LOW', 'ORIG', 'NEG', '?');
  HDN: array [0..15] of char ='0123456789ABCDEF';
var
    c: char;
    n:string[14];
    vst  {, lst} : text;
    i,p,Indb,nb,Col,Sp: word;
    b,j,RW,k,l,ll,ls,lr, SQs, Style, o : byte;
    InQB: longint;
    AoQB: array[1..24,0..3] of byte;
    AoLI: array[1..24] of longint absolute AoQB;
    AoLI2: array[1..24] of longint;
    AoDB: array[1..12] of array [2..3] of byte;
    AoI:  array[1..12] of integer absolute AoDB;
    ins: string;
    inb: array [0..256] of byte absolute ins;
    insc: array [0..256] of char absolute ins;
    MS:  string[36]; {1st,2nd,3rd row}
    MB:  array [0..36] of byte absolute MS;
    OBL: array [1..5,1..1901] of byte;
    OCL: array [1..5,1..1901] of char absolute  OBL;
    Answer : Char;
    S, WasGrChar: Boolean;

Procedure Help;
begin
  writeln(
'Program pro tisk temp-souboru T2.txp, "vytisklho" T602 pi uit Simple.dst;');
  writeln(
'               ev. jin jmno souboru me bt zadno jako prvn parametr.');
writeln('Jako dal parametry mohou bt zadna hesla:');
writeln('  SP   - tisk po jednotlivch stranch s dotazem na ev. ukonen,');
writeln('  Cond - tisk vekerho textu v reimu CONDens (zen na 7/12)');
writeln('  Left - program se opt na polohu levho okraje,');
writeln(
'  Page - program se opt na slo prvn strany, kter se m tisknout,');
writeln('  Pica - psmena dle od sebe - 10.3 msto 12 na palec,');
writeln('  Gr   - cel tisk v grafickm mdu,');
writeln(
'  LQ   - v textovm mdu tisknout ve dvojnsobn hustot (kvalitn),');
  writeln(
'  72   - v grafickm mdu tisknout ve dvojnsobn velikosti hustotou 72 DpI),');
  writeln(
'  144  - v grafickm mdu tisknout ve dvojnsobn velikosti hustotou 144 DpI),');
writeln('  Low  - tisknout pes spodn stopu barvic psky,');
writeln('  Orig - irok a Velk psmo tisknout pvodnm zpsobem,');
writeln('  Neg  - Obrzky tisknout jako negativ');
writeln('a ? nebo nesprvn parametr  - zobrazen tchto pokyn.');
writeln;
writeln('Znaka ELITE uit v textu slou jako pepna:');
writeln(
'Pi volb "Gr" se tiskne dek dvakrt zvten (72 DpI), pi volb "72" je');
writeln(
'  tomu naopak, tiskne se 144 DpI. Rozhoduje posl. El., za nm nco v dku je.');
writeln(
'V textovm reimu se ohranien st tiskne dvojitm (pomalm) tiskem,');
writeln(
'  pi volb "LQ" naopak tiskem konceptnm (rychlm). Na dku lze stdat.');
writeln(
'Znaka Ctrl+P,1 v textu zapn/vypn kurzivn font, ..,2 indexov.');
writeln(
'(Jan Hollan, source at http://astro.sci.muni.cz/pub/hollan/programmes)');

halt
end;

procedure Done;
begin
{initialisation of the printer to the standard values}
 write(lst,#139,'A00'); {left margin}
 write(lst,#27#51);     {draft}

 close(vst);
 close(lst);
 halt
end;


function BreaT : boolean;
var c: char;
begin
     BreaT:= False;
     if KeyPressed then
      begin
        while KeyPressed do c:=readkey;
        write('Pokraovat v tisku? (pokun ne, stiskni N): ');
        c:= ReadKey; writeln(c);
        if (c='n') or (c='N') then BreaT:= True ;
      end;
end;

Procedure ProGrLi; {Processing a rest of line with graphic data}
var w: word;
    d,e:char;
    b,b1,g,l:byte;
    count:word;
    inas: string;
    ConGr: boolean;  {true if data are to be twice condensed horizontally}
begin
 repeat
      if BreaT then Halt;
      read(vst,c); if c=#90 then ConGr:= True else ConGr:= False;
      if SCond then w:= inb[0] * 7  else w:=inb[0] * 12;
      write(lst,#128,chr(Lo(w)),chr(Hi(w)));
      read(vst,d,e);
      count:=ord(d)+256*ord(e);
      if ConGr then begin
       i:= count div 2 ; j:= i div 256; e:= chr(j); d:= chr(i - 256*j) end;
      write(lst,d,e);
      for i:=1 to count do
        begin
          b:=0;
          read(vst,c);
          g:=ord(c);
          for l:= 1 to 8 do     {reversing the order of bites}
                  b:= b + ((g and BS[l]) div BS[l])*BS[9-l];
          if ConGr then
            If Negative then
                  if odd(i) then b1:=b else
                        write (lst,chr(not(b or b1)))
             else
                  if odd(i) then b1:=b else
                        write (lst,chr(b or b1))
          else
            if Negative then write(lst,chr(not b))
                      else           write(lst,chr(b))
        end; {of graphic bytes inverting}
      write(lst,#130);
      read(vst,c);
      if c<>#27 then WRITELN('not an Esc');
      read(vst,c); if c<>#51 then writeln('not a Shift sequence');
      read(vst,c); if c<>#24 then writeln('Shift <> #24');
      readln(vst);
      read(vst,c); inb[0]:= 1; insc[1]:= c;
      while c=#32 do
            begin inb[0]:=inb[0]+1; read(vst,c); insc[inb[0]]:=c end;
      if c=#27 then inb[0]:= inb[0]-1;
  until c<>#27;
      {the following line must not be a graphic one}
  readln(vst,inas);
  OldShift:= #130#130#130;
  WasStandard:= False;
  ins:= ins+inas;
end;


Procedure InpLine;
begin
  j:= 0;
  repeat inc(j); read(vst,insc[j]);
  until (inb[j]=27) or (inb[j]=13) or (inb[j]=12) or EOF(vst);
  inb[0]:= j-1;
  case inb[j] of
   12:  NewPage:=true;
   27:  ProGrLi;  {process a draft graphic line}
   13: begin
        read(vst,c);
        if c<>#10 then write('Po CR nen LF - chyba!')
       end
   end
end;

Function NPage : boolean;
begin
  NPage:= False;
  write(lst,#12);
  NewPage:=false;
  if SinglePages then
    begin                               {SP option}
       write('Dal stranu? (Y/n): ');
       readln(Answer);
       if (Answer='n') or (Answer='N') then NPage := True
     end
end;


function SwT : char;
begin
  if LQ then SwT:= #51 else SwT:= #50;
  LQ:= not LQ
end;

Procedure SwG;
begin
 if GS=#129 then GS:= #128 else GS:= #129;
 SwGS:= False
end;

procedure GraIni;
begin
  write(lst,GS,#0#0#0#0) {initialisation of 144 DpI graphic print}
end;

function Half(b,s: byte) : Byte; 
var i: byte;
begin
  o:=0;
  for i:= 1 to 8 do
    inc(o,BS[i] * ((b and BS[s+((i+1) div 2)]) div BS[s+((i+1) div 2)]));
  Half:= o;
end;

Procedure LarPrin(s: byte);
begin
          write(lst,GS,chr(Lo(Sp)),chr(Hi(Sp)),chr(Lo(nb)),chr(Hi(nb)));
          for Col:=i to p do
            begin 
              c:= chr(Half(OBL[j,Col],s));
              for l:= 1 to 2 do write(lst,c)
            end
end;


Procedure PriGrLine;
var Something:boolean;
begin
  Something:= False; i:=0;
  while (not Something) and (i<p) do
    begin
      i:= i+1;
      if OBL[j,i] > 0 then Something:= True
    end;
  if Something then
    begin
      if SCond then Sp:= Spaces*7 else Sp:= Spaces*12;
      if GS=#129 then Sp:= Sp div 2;
      Sp:= Sp + i-1; nb:= p-i+1;
      if G144 then
        begin
          Sp:= Sp * 2;
          nb:= nb * 2;
          LarPrin(0);
          write(lst,#130);
          LarPrin(4);
        end
       else
        begin
          write(lst,GS,chr(Lo(Sp)),chr(Hi(Sp)),chr(Lo(nb)),chr(Hi(nb)));
          for Col:=i to p do write(lst,OCL[j,Col])
        end
    end;
  write(lst,#130);
end;

begin
 {rewriting character Pt (for M.Z.) to become a symbol of partial derivation:}
  seq[145]:=  #56#69#69#69#62#0;
  MapS[145]:= #0#128#66#33#17#17#17#17#18#34#248#0#0#3#4#8#16#16#16#16#8#6#1#0;
  MapI[145]:= #0#128#66#34#17#17#17#17#17#34#252#0#0#7#8#16#16#16#16#8#12#3#1#0;
 {initialization:}
  Spaces:= 0;    GS:= #128; ThBL:= False; Negative:= False; G144:= False;
  AllGr:= False; LQ:= False; G72:= False; NoStart:=False; UnderLine:= False;
  Cond:= False;  SCond:= False;  Pica:= False; WasStandard:= False;
  Page:= 1;  W:=12 {Width of a letter - number of columns};  SwGS:= False;
  n:=getenv('TEMP')+'t2.txp';
  SQ:= 0;       {Mode of writing; 0 - standard letters}
  Shift:= 0;    {5: 6 lines per inch, 6: 4 lines, 7: 3 lines per inch}
  OldShift:= #130#130#130;   {sequence for another LpI to be sent to the printer}
  FillChar(Zeros,12,#0);
  SinglePages:= False;   {No Prompt after each page}
  HL:= False;            {Initilisation of High Letters to No}
  Italic_font:=false;
  Indices_font:=false; NewPage:=false;

 {  assign(lst,GetEnv('TEMP')+'t2.prn');
    rewrite(lst);
  }                       {- may be activated for checking the program}

  if ParamCount > 0 then            {interpreting parameters }
    for j:= 1 to ParamCount do
      begin
        MS:= ParamStr(j);
        for k:= 1 to MB[0] do
          MS[k]:= UpCase(MS[k]);
        b:= 0;
        for k:= 1 to 13 do
          if MS = ParamAr[k] then b:= k;
        case b of
           1: SinglePages:= True;
           2: begin Cond:= True; SCond:= True end;
           3: begin
               write('Poet mezer na levm okraji: ');
               readln(l);
               write(lst,#139,'A0300',
                         HDN[l div 16],HDN[l - 16*(l div 16)],#13)
              end;
           4: begin
               write('slo prvn strany, kter se m tisknout: ');
               readln(Page);
              end;
           5: Pica:= True;
           6: AllGr:= True;
           7: begin LQ:= True; write(lst,#27#50) end;
           8: begin G72:= True; GS:= #129 end;
           9: G144:= True;
          10: write(lst,#18);
          11: ThBL:= True;
          12: Negative:= True;
         else if (j=1) and not((MS[1]='/') or (MS[1]='?')) then
                  n:= ParamStr(1)
              else Help;
        end;      {of Case}
      end;  {of Parameters section}
  {$I-}
  repeat
   assign(vst,n);
   reset(vst);
   if IOResult <> 0 then
     begin
      writeln('Vstupn soubor ',n,' nebyl nalezen;');
      writeln(
'   zadejte sprvn (pln) jmno, nebo jen ukonete program stiskem Enter.');
      readln(n);
      if length(n)=0 then Help;
     end
    else Open:= True;
  until Open;

  {$I+}

  GraIni;    {initialisation of graphic mode}
  j:= 1;
  if Page > 1 then     {finding the first page that is to be printed}
    begin
      while (not eof(vst)) and (j<Page) do
        begin
          readln(vst,ins);
          for l:= 1 to inb[0] do
           case inb[l] of
            12: j:= j+1;
            27: l:= inb[0]-1; {to skip a rest of line written in graphic mode}
            end;
        end;
          if inb[0] = 1 then
            inb[1]:= 5
           else  {it must not be a graphic line!}
            ins:= copy(ins,pos(#12,ins)+1,inb[0]-pos(#12,ins));
    end

   else   InpLine;

 repeat    {processing the input file line by line until eof}
     if NoStart then InpLine;
     if eof(vst) and (inb[0]=0) then Done;
     i:=0;
     S:= True; HL:= False;


     if BreaT then Done;

     if NewPage and (inb[0]=0) then {the line begins with a Form Feed
                            - no characters before it to be processed}
       begin
        if NPage then Done;
        InpLine;
        if inb[0]=0 then begin inb[0]:=1; inb[1]:=Shift end;
                         {but it should not happen}
       end;

     if NewPage then inc(inb[0]); {horrible cheating; the last character
        before CR is a shift value in another cases -
        there is no such character before FF, but the length of
        the string is to be modified as if it were there
        (processing of that character is of course skipped if NewPage)}

      if (not Cond) and (not AllGr) then       {if no Cond or Gr option, }
   {2b} begin                          { non-standard letters are looked for}
         while S and (i<inb[0]) do
      {3b} begin i:= i+1;
             case inb[i] of
               2..11,13..31: S:= False;
              end;
      {3e} end;

         if i=inb[0] then S:= True             {just standard letters used}
   {2e} end
       else S:= False;

                                     {were the high letters used? }
     if pos(#16,ins)>0 then HL:= True
        else if pos(#29,ins)>0 then HL:= True;

                                     {nothing more than a new line? }
     if inb[0] = 1 then
        begin
          if WasStandard then write(lst,OldShift,#13)
             else write(lst,copy(OldShift,1,Length(Oldshift)-2),#13);
        {after a graphic line, the head is 8"/72 (or 16"/72 in 72 Dpi mode)
         lower than after a text line (when WasStandard has been set to True)}
          WasStandard:= True
        end

      else

       if S then
        {just standard letters used: writing the line in a text mode }
   {2b}     begin
                if WasStandard then write(lst,OldShift)
                   else write(lst,copy(OldShift,1,Length(Oldshift)-2));
                WasStandard:= True; WasGrChar:= False;
                for i:= 1 to inb[0]-1 do
                 begin
                  case inb[i] of
                   1      : write(lst,#27,SwT); {Elite switch}
                   32..127: write(lst,insc[i]) ; {no conversion}
                    else    if length(seq[inb[i]])<6 then
                                write(lst,seq[inb[i]])   {text mode}
                              else
                                begin
                                  write(lst,#129#0#0#6#0,seq[inb[i]]);
                                  WasGrChar:= True     {printed in graphics}
                                end
                    end; {of case}
                  end;   {of for}
                write(lst,#13);
                if WasGrChar and (GS=#128) then GraIni;
   {2e}     end
        else     {to be sent as three or five graphic lines}
   {2b}     begin
              FillChar(OCL,9505,#0); {emptying Output graphic data}
              p:=0;   {length of a graphic row}
              ls:=1;  {position of a first non-space character}
              Spaces:=0;   {number of leading spaces : }
              while inb[ls]=32 do
     {3b}       begin
                  Spaces:= Spaces + 1;
                  ls:= ls+1
     {3e}        end;

              for i:= ls to inb[0]-1 do  {for the remaining characters}

                  if inb[i] < 32 then
     {3b}            begin               {interpreting a switch}
                      b:= inb[i];
                      if b = SQ then SQ:=0
                        else
                          case b of
                          19: UnderLine:= not UnderLine;
                           3: Cond:= not Cond; {a Condens way; even: on}
                           1: if AllGr or G72 or G144 then SwGS:= True;
                          17: Italic_font:=not Italic_font;
                          18: Indices_font:= not Indices_font;
                           else SQ:=b;     { new Style}
                           end;
     {3e}            end

                   else  {i.e., if  32 }
     {3b}            begin
                      if SwGs then SwG;
                                    {filling MS with BitMap of the character}
                      if (SQ=4) or Italic_font then
                          MS:=MapI[inb[i]]      {Italics }
                      else if (SQ=20) or (SQ=22) or Indices_font then
                             MS:=MapE[inb[i]]   {Indices }
                           else    {normal letters}
                             MS:= MapS[inb[i]]; {character's map (basic size)}

                      if length(MS) < 36 then MS:=Zeros+MS;
                                      {filling the missing upper row with 0s}

                      if ThBL and (SQ=15) then SQs:= 29 else SQs:=SQ;

        {4b}          case SQs of   {adding corr. bytes to the Output lines}

                        2 : for j:= 1 to 3 do   {Thick letter}
           {5b}               begin
                                  l:= W*(j-1);
                                  OBL[j,p+1]:= MB[l+1];
                                 for k:= 2 to W do
                                  OBL[j,p+k]:=  MB[l+k] or MB[l+k-1];
                                 {the OutputByteLineNumber array made by
                                  adding the preceding column}
           {5e}               end;

           {5b}         15 :begin
                            for j:= 1 to 3 do     {Broad, a less thick scheme}
             {6b}              begin               { than that of T602.}
                                 l:= W*(j-1);
                                 OBL[j,p+1]:= MB[l+1];
                                 for k:= 1 to W-1 do
                                  begin
                                    OBL[j,p+2*k]:= MB[l+ k+1] or MB[l+ k  ];
                                    if j<>1 then AoDB[k,j]:= OBL[j,p+2*k]
                                  end;
                                 k:= W;
                                 OBL[j,p+2*k]:= MB[l+k];
                                 if j<>1 then AoDB[k,j]:= OBL[j,p+2*k]
             {6e}             end;
                             for k:= 1 to (W-1) do
             {6b}             begin
                                  OBL[1,p+2*k+1]:=
                          ((OBL[1,p+2*k] ShL 1) and (OBL[1,p+2*k+2] ShR 1)) or
                          ((OBL[1,p+2*k] ShR 1) and (OBL[1,p+2*k+2] ShL 1)) or
                          ( OBL[1,p+2*k]        and  OBL[1,p+2*k+2] ) ;
                                  OBL[1,p+2*k+1]:=
                          (OBL[1,p+2*k]   and OBL[1,p+2*k+1]) or
                          (OBL[1,p+2*k+2] and OBL[1,p+2*k+1]) ;
                                  Indb:=
                          ((AoI[k] ShL 1) and (AoI[k+1] ShR 1)) or
                          ((AoI[k] ShR 1) and (AoI[k+1] ShL 1)) or
                          ( AoI[k]        and  AoI[k+1] ) ;
                            {discarding isolated artificial columns: }
                              Indb:= (Indb and AoI[k]) or (Indb and AoI[k+1]);

{      If ((AoI[k] ShR 2) and AoI[k+1])=AoI[k+1] then Indb:= AoI[k+1] else
       If ((AoI[k] ShL 2) and AoI[k+1])=AoI[k+1] then Indb:= AoI[k+1] else
       If ((AoI[k+1] ShL 2) and AoI[k])=AoI[k] then Indb:= AoI[k] else
       If ((AoI[k+1] ShR 2) and AoI[k])=AoI[k] then Indb:= AoI[k]     ;
  - this was an attempt to make, e.g., the crossing in letter t plain    }

                                  OBL[2,p+2*k+1]:=Lo(Indb);
                                  OBL[3,p+2*k+1]:=Hi(Indb);
           {6e}               end;
                             k:= 2*W
         {5e}              end;

                        22:   for k:=1 to W do     {lower index}
                               begin
                                 Indb:= MB[W+k] shl 5 + MB[2*W+k] shl 13;
                                 OBL[3,p+k]:= Hi(Indb);
                                 OBL[2,p+k]:= Lo(Indb)
                               end;
                                {it was shifted 5 points downwards}

                        29: for j:= 1 to 3 do     {Large}
           {5b}               begin
                                 l:= W*(j-1);
                                 OBL[j,p+1]:= MB[l+1];
                                 for k:= 2 to 2*W-1 do
                                  OBL[j,p+k]:= MB[l+((k+2) div 2)] or
                                               MB[l+(  k   div 2)];
                                 k:= 2*W;
                                 OBL[j,p+k]:= MB[l+W];
           {5e}                end;

                      else  for j:= 1 to 3 do     {just copying}
           {5b}               begin
                                  l:= W*(j-1);
                                  for k:= 1 to W do
                                    OBL[j,p+k]:= MB[l+k];
           {5e}               end;
        {4e}             end; {of case command
                                  writing the character into the OBL array}
                       RW:= k;

                       if (SQ = 16) or (SQ = 29) then
        {4b}              begin             {making the letter High}
                           for k:= 1 to RW do
           {5b}             begin
                             OBL[5,p+k]:= OBL[1,p+k];
                             b:= OBL[2,p+k];
                             OBL[4,p+k]:= Half(b,0);
                             OBL[1,p+k]:= Half(b,4);
                             b:= OBL[3,p+k];
                             OBL[2,p+k]:= Half(b,0);
                             OBL[3,p+k]:= Half(b,4);
           {5e}             end
        {4e}              end;
                                 {ev. smoothing and thinning the letter: }
                      if (SQ=29) and not ThBL then
        {4b}            begin
                          for k:= 1 to RW do
           {5b}            begin
                            AoQB[k,0]:= OBL[4,p+k];
                            for j:= 1 to 3 do AoQB[k,j]:= OBL[j,p+k]
           {5e}            end;
                          for k:= 2 to RW-1 do
           {5b}            begin
                              InQB:=
                               ((AoLI[k-1] ShL 1) and (AoLI[k+1] ShR 1)) or
                               ((AoLI[k-1] ShR 1) and (AoLI[k+1] ShL 1)) or
                               ( AoLI[k-1]        and  AoLI[k+1] ) ;
                              AoLI2[k]:= InQB;
            {5e}           end;
                          for k:= 2 to RW-1 do AoLI[k]:= AoLI2[k];
            {5b}          for k:= 2 to RW-1 do
                           begin
                             OBL[4,p+k]:= AoQB[k,0];
                             for j:= 1 to 3 do OBL[j,p+k]:= AoQB[k,j]
            {5e}           end;
          {4e}          end;

                       if Cond  then
        {4b}              begin {compressing to RW/2 columns +1(2) empty ones}
                           RW:= RW div 2;
                           for j:=1 to 5 do
            {5b}            begin
                             for k:=1 to RW do
                               OBL[j,p+k]:= OBL[j,p+2*k] or OBL[j,p+2*k - 1];
                             for k:= 1 to RW do OBL[j,p+RW+k]:= 0;
            {5e}            end;
                           if RW=12 then k:= RW+2 else k:=RW+1;
                           RW:= k
        {4e}              end;
                                         {underlining the character: }
                       if UnderLine then
                        if (SQ=16) or (SQ=29) then
                          for k:= 1 to RW do OBL[3,p+k]:= OBL[3,p+k] or 192
                         else
                          for k:= 1 to RW do OBL[3,p+k]:= OBL[3,p+k] or 128;

                       p:= p + RW;

                       if Pica then if Cond then p:= p+1 else p:=p+2;

     {3e}            end; {of a cycled if-command -
                           processing one graphic character }

        {shifting the paper and writing the line as up to 5 graphic lines:}
              if WasStandard then write(lst,#130#130);
              WasStandard:= False;
              if not (Shift=5) then write(lst,#130); {either 4.5 or 3 LpI}
              if not HL then
                 begin
                  if (Shift = 7) then write(lst,#130#130)  {3 Lines per Inch}
                 end
                else
                 for j:=5 downto 4  do PriGrLine;  {upper 2 gr.l. of a line
                                                  including high letters}
              for j:=1 to 3 do  PriGrLine ;  {standard three graphic lines}
              if SwGS then SwG;

   {2e}     end; {of printing a line of any kind}

     if NewPage then if NPage then Done;
     if (inb[inb[0]]<>Shift) and not NewPage then
              {setting the new shift on the next line}
   {2b}   begin
             Shift:=inb[inb[0]]; {Shift : the actual line density}
             OldShift:=#130#130#130;
     {3b}    case inb[inb[0]] of
                    6: OldShift:= OldShift+#130;
                    7: OldShift:= OldShift+OldShift;
     {3e}         end;
   {2e}    end;

    NoStart:= True;

 until eof(vst);

 Done;
end.