Program TiskCSE9;
{            written 1992-06-01, last time corrected 1994-02-04
     by J. Hollan, Obs. and Planetarium, 616 00  Brno.

     Printing of a graphic file for a 9-needle Epson printer
                               on the CS212-25 graphic printer.
     The file is supposed to be on a disk (virtual, presumably) D:,
                               and named t2.gE9.
     The program is meant for printing figures or even "T602-texts".
}
uses Printer, crt;
type OutRow= array [1..3992] of byte;

var d,e,c,WGD,WGS,CR,t,u:char;
    n:string[36];
    vst : file ;
{     lst: text; {- for the case of checking the program}
    j,Shift:integer;
    i: word;
    b,b1,g,k,l,Spaces:byte;
    count:word;
    posun: char; Bposun: byte absolute posun;
    Cond {switch for condensing}, Negative, Open, Decomp,
    Full,DSize, no_shift: boolean;
    MS:  string[36]; {1st,2nd,3rd row}
    MB:  array [0..36] of byte absolute MS;
    UpRow, LoRow, IBRow : OutRow;
    ICRow: array [1..3992] of char absolute IBRow;

const   cl=#13#10;
    posuny: array [1..8] of char =(#36,#54,#72,#12,#30,#48,#24,#24);
        HDN: array [0..15] of char ='0123456789ABCDEF';
    ParamAr: array[1..5] of string[5] = ('NEG','LEFT', 'LOW','DSIZE','?');
         BS: array [1..8] of byte = (1,2,4,8,16,32,64,128);

Procedure Help;
begin
  writeln(cl,'Program for printing a "graphic" file for a 9-needle Epson ',
          'printer');
  writeln('       on a CS212-25 printer (or a similar one).');
  writeln('       D:T2.gE9 is a standard name of this file, ');
  writeln('       another name may be given as the first parameter.');
  writeln;
  writeln('Options are: Neg  - convert to Negative');
  writeln('             Left - prompt on number of spaces',
                              ' to be added at Left Margin');
  writeln('             Low  - Lower track of tape');
  writeln('             DSize- Magnify twice');
  writeln('and  ?  or  invalid second or further parameter - this Help text');
  writeln;
  writeln(
'(C) 94-02-04 by Jan Hollan, Observatory and Planetarium, 616 00 Brno',cl,
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'
);

end;

function BreaT : boolean;
var c: char;
begin
     BreaT:= False;
     if KeyPressed then
      begin
        while KeyPressed do c:=readkey;
        write('Pokraovat v tisku? (pokun ne, stiskni N): ');
        c:= ReadKey; writeln(c);
        if (c='n') or (c='N') then BreaT:= True ;
      end;
end;

Procedure Reverse (var Row: OutRow; downlim,uplim,start,coef,decr: byte);
begin
 for i:= 1 to count do
   for l:= downlim to uplim do
    Row[i]:=Row[i]+((IBRow[i] and BS[l]) div BS[l]) * BS[start-coef*(l-decr)];
end;

function Half(b,s: byte) : Byte; 
var i,o: byte;
begin
  o:=0;
  for i:= 1 to 8 do
    inc(o,BS[i] * ((b and BS[s+((i+1) div 2)]) div BS[s+((i+1) div 2)]));
  Half:= o;
end;

Procedure LarPrin(var Row:outrow; s: byte);
var cc:char; l:byte;
begin
  write(lst,WGD,chr(Lo(Spaces*24)),chr(Hi(Spaces*24)),
              chr(Lo(count*2)),chr(Hi(count*2)));
  for i:=1 to count do
            begin
              cc:= chr(Half(Row[i],s));
              for l:= 1 to 2 do write(lst,cc)
            end
end;

Procedure SLarPrin(var Row: OutRow; s: byte);
var cc:char; l:byte;
begin
  write(lst,WGD,chr(Lo(Spaces*12)),chr(Hi(Spaces*12)),
              chr(Lo(count)),chr(Hi(count)));
  for i:=1 to count do
            begin
              cc:= chr(Half(Row[i],s));
              write(lst,cc)
            end
end;




Procedure WriGr (var Row: OutRow); {writes and empties an array}
begin
  If Negative then
    for i:=1 to count do
     Row[i]:=not Row[i];
  if not Cond then
    begin
      if not DSize then
        begin
          write(lst,WGD,chr(Lo(Spaces*12)),chr(Hi(Spaces*12)),d,e);
          for i:=1 to count do write(lst,chr(Row[i]))
        end
      else {if the ouptut is to be twice magnified}
        begin
          LarPrin(Row,0);
          write(lst,#130);
          LarPrin(Row,4);
        end

     end
  else   {if the output is to be compressed : }
     begin
       if not DSize then
         begin
           i:= count div 2 ; e:= chr(Hi(i)); d:= chr(Lo(i));
           write(lst,WGD,chr(Lo(Spaces*12)),chr(Hi(Spaces*12)),d,e);
           for i:=1 to count do
             if odd(i) then b1:=Row[i] else
              write (lst,chr(Row[i] or b1));
         end
       else {if the ouptut is to be twice magnified}
         begin
           SLarPrin(Row,0);
           write(lst,#130);
           SLarPrin(Row,4);
         end;
     end;
   FillChar(Row,3992,0); Full:= False; no_shift:=true;
end;

procedure send_all;
 begin
  if Full then
     if Decomp then   {decomposition into lower halves
                                       of graphic lines}
        begin
         Reverse(LoRow,1,4,10,2,0);
         Reverse(UpRow,5,8,10,2,4);
         WriGr(UpRow); Write(lst,t); WriGr(LoRow);
        end
      else
        begin
         Reverse(UpRow,1,8,9,1,0);
         WriGr(UpRow)
        end
  else write(lst,t);   
  Decomp:= False;
  if Shift>0 then
     for l:= 1 to Shift do write(lst,t)
                    else write(lst,#13)
end;

begin
  {initialisation }
  WGD:=chr(128);{WGS:=chr(129);}
  t:=chr(130); Negative:= False;
  FillChar(UpRow,3992,0); FillChar(LoRow,3992,0);
  Decomp:= False; Full:= False; Spaces:=0;
  Shift:=1; DSize:= False; no_shift:=true;

{n:='f:t2.prn'; assign(lst,n); rewrite(lst);
                           {For checking the output:} 
  n:='d:t2.gE9';  

  if ParamCount > 0 then            {interpreting parameters }
    for j:= 1 to ParamCount do
      begin
        MS:= ParamStr(j);
        for k:= 1 to MB[0] do
          MS[k]:= UpCase(MS[k]);
        b:= 0;
        for k:= 1 to 5 do
          if MS = ParamAr[k] then b:= k;
        case b of
           1: Negative:= True;
           2: begin
               write('Number of spaces at left margin: ');
               readln(l);
               write(lst,#139,'A0300',
                         HDN[l div 16],HDN[l - 16*(l div 16)],#13)
              end;
           3: write(lst,#18);  {Lower track of the tape}
           4: DSize:= True;
         0,5: if (j=1) and (b=0) then n:= ParamStr(1) else begin
                Help; exit end;
          end;      {of Case}
      end;  {of Parameters section}
  {$I-}
  repeat
   assign(vst,n);
   reset(vst,1);
   if IOResult <> 0 then
     begin
      writeln('The input file ',n);
      writeln('   was not found, try to give the correct full name,');
      write('   or just pres Enter to abort the program:');
      readln(n);
      if length(n)=0 then begin Help; exit end;
      Open:= False
     end
    else Open:= True;
  until Open;

  {$I+}

  while not eof(vst) do
    begin
      if BreaT then exit;
      BlockRead(vst,u,1);
      case u of
       #13 : Spaces:= 0 ;
       #10 : if Full and no_shift then {LF without a preceding sequence saying the
                           amount of vert. shift}
               send_all;
       #32 : Spaces:= Spaces+1;
       #12 : for l:= 1 to 6 do write(lst,t);
                   {instead of FF, just 6 lines, esp. to avoid the final FF}
       #27 :
         begin {of Esc branch }
          blockread (vst,c,1);
          case c of
           #64 {@},#79 {O} : ;
           #74 {J}:  {vertical shift is ignored}
                     repeat blockread(vst,c,1) until c=#10;
           #51 {3}:     {Amount of vertical shift in 1"/216 for one LF}
            begin
             blockread(vst,posun,1);
             no_shift:=false;
             if odd(Bposun) then
                Shift:= (Bposun+1) div 12 - 1
              else
                Shift:= (Bposun + 12) div 24 ;
             if Bposun <> 1 then send_all

              else      {minishift, perhaps 144 DpI data to be decomposed
                         into the upper halves of the two graphic lines}
                  Begin
                    Decomp:= True;
                    If Full then
                     begin Reverse(LoRow,1,4,9,2,0); Reverse(UpRow,5,8,9,2,4)
                     end
                   end
            end;  {of branch #51}

           #65 {A}:     {Amount of vertical shift in 1"/72 for one LF}
            begin
             blockread (vst,posun,1);
             Shift:= (Bposun) div 8;
            end;

           #76{L},#89{Y},#90{Z},#42{*} :
           begin                             {start graphic data}
            if c=#42 then blockread(vst,c,1);
            if (c=#90) or (c=#3)
               or (c=#7) then Cond:= true  else Cond:= false ;
             {the data will be twice condensed if Cond}
            blockread(vst,d,1); blockread(vst,e,1); count:=ord(d)+256*ord(e);
            BlockRead(vst,ICRow,count);
            Full:= True;
           end;   {of branch of graphic data, i.e. #42 etc.}
          end;  {of case after Esc}
        end; {of Esc branch}

       else
         begin
           if Spaces>0 then
              begin
                for l:= 1 to Spaces do write(lst,' ');
                Spaces:= 0
              end;
           write(lst,u)
         end;

      end; {of whole case}

    end; {of while not eof}
    close(vst); {close(lst); {for checking the ouptput}
end.
