 {~ reads orbital elements of a comet from a xephem- or mpc-format text file ~}

unit elm; {by JenikHollan, used by posi, map_mgsc and map_bsc}
interface
uses str_num;
const
 Loc_obj_const =
 'c:\d\sol_syst;c:\d\j\d\sol_syst;'+
 'c:\d\stars;c:\d\stars\atlas;'+
 '/home/jhollan/public_html/data;'+
 '/home/guest/cats;'+
 'g:\cats';
 Loc_obj : string[120] = Loc_obj_const;
h_dir_elem=
 'LE<directories with orbital elements and configuration files>'+cl+
 '   (default '+Loc_obj_const+')'+cl;
 excentricity:real=0;
 asc_node:real=-999;
 perih_from_asc_node:real=-999;
 perih_comp_length:real=-999;
 inclin:real=-999;
 semiaxis_large:real=-999;
 perih_pass:real=-999;
 perihel_dist:real=-999;
 anomaly_date:real=-999;
 mean_anomaly:real=-999;
 daily_motion:real=-999;
 Comet:boolean=false;
 Comet_exponent:real=2;
 Faint_abs:real=-20;

 ElmCatNameDefault:string='xephem.dat';
 ElmCatNameKind:byte=1; {for the xephem format, 2 means the MPC format}

function
 get_orbital_elements(format:byte; elmcatname,identstr:string):boolean;

implementation

uses angles_o,solar_ut,un_str_m;
var elmcat:text; line,s:string;

function
 get_orbital_elements(format:byte; elmcatname,identstr:string):boolean;
  function mpc(st,le:byte):real;
   begin
    mpc:=R_S(__CvtStr(copy(line,st,le),_rem_white_str));
   end;
 begin
  get_orbital_elements:=false;
  if rt_reset(loc_obj,elmcat,elmcatname) then
   case format of
    1: {xephem}
     repeat
      readln(elmcat,line);
      if pos(identstr,itemStrD(',',1,line))>0 then
       begin
        excentricity:=R_S(ItemStrD(',',8,line));
        asc_node:=deg_to_rad(R_S(ItemStrD(',',4,line)));
        perih_from_asc_node:=deg_to_rad(R_S(ItemStrD(',',5,line)));
        inclin:=deg_to_rad(R_S(ItemStrD(',',3,line)));
        semiaxis_large:=R_S(ItemStrD(',',6,line));
        {perih_pass:real=-999;}
        {perihel_dist:real=-999;}
        s:=ItemStrD(',',10,line);
        anomaly_date:=JD0(
         I_S(ItemStrD('/',3,s)),
         I_S(ItemStrD('/',1,s)),
         trunc(R_S(ItemStrD('/',2,s)))
                          )
         +frac(R_S(ItemStrD('/',2,s)))
         -JD_MJD;
        mean_anomaly:=R_S(ItemStrD(',',9,line));
        daily_motion:=R_S(ItemStrD(',',7,line));
        Comet_exponent:=R_S(ItemStrD(',',13,line));
        if Comet_exponent>2 then Comet:=true;
        Faint_abs:=R_S(ItemStr(2,ItemStrD(',',12,line)));
        get_orbital_elements:=true;
        exit;
       end
     until eof(elmcat);
    2: {MPC}
     repeat
      readln(elmcat,line);
      if pos(identstr,copy(line,103,length(line)-102))>0 then
       begin
        excentricity:=mpc(42,9);
        asc_node:=deg_to_rad(mpc(62,10));
        perih_from_asc_node:=deg_to_rad(mpc(52,9));
        inclin:=deg_to_rad(mpc(73,8));
        {semiaxis_large:=}
        perih_pass:=JD0(
         I_S(copy(line,15,4)),
         I_S(copy(line,20,2)),
         trunc(mpc(23,8))
                          )
         +frac(mpc(23,8))
         -JD_MJD;
        perihel_dist:=mpc(32,9);
        {anomaly_date:=}
        {mean_anomaly:=R_S(ItemStrD(',',9,line));}
        {daily_motion:=R_S(ItemStrD(',',9,line));}
        Comet_exponent:=mpc(97,4);
        if Comet_exponent>2 then Comet:=true;
        Faint_abs:=mpc(92,4);
        get_orbital_elements:=true;
        exit;
       end
     until eof(elmcat);
   end;
 end;
end.
