      {~ opening and reading ST# (SBIG CCD camera) files ~}

     {made for Rudolf Novak from the FITSstVw programme, March 2000}

unit sbig; {by Jan Hollan, subject to the GNU public license}

interface

uses dos, {standard unit}
     ftbridge; {J.H,'s unit}
var
  bufw: FtImLine2Type absolute FtImLine2;
       {line with data 1..line_length}
const
  line_count: word = 1;
  line_length : word = 1;
  Rang: word = 255;         {range of the image}
  Back: word = 0;           {background value of the image}

Function  ST_Open(FilePath:dirstr;FileName:pathstr):boolean;
            {opens a file, true if successful}
procedure ST_sof;   {go to the first line, useful for repeated reading}
procedure ST_line;  {read a line into bufw}
procedure ST_Close; {closes the file}

implementation

uses angles_o, str_num; {J.H.'s units}

var inp: file; line_length_byte:word;
const compressed: boolean=false;

Function ST_Open(FilePath:dirstr;FileName:pathstr):boolean;
Type
  Condition = (UNK,Range,Background,Width,Height);
Var
  Symb : Condition; Name:string; Value:word;
  inh:text; stri:string; i:byte; h,w:word;
const
  NofCon=5;
  SwitchArray : array[1..NofCon] of string[10] =
   ('UNK','Range','Background','Width','Height');
  CondArray : array[1..NofCon] of Condition =
    (UNK,Range,Background,Width,Height);
begin
  if rt_reset(FilePath,inh,FileName) then
   begin
    ST_Open:=true;
    readln(inh,stri);
    if pos('Compressed',stri)>0 then compressed:=true;
    for i:=2 to 30 do
     begin
      readln(inh,stri);
      h:=pos(' ',stri);
      if h>0 then
       begin
        Name:=copy(stri,1,h-1);
        Symb:=UNK;
        for w:= 1 to NofCon do
         if Name=SwitchArray[w] then Symb:=CondArray[w];
        if Symb<>UNK then
         begin
           Value:=round(
             N_S(copy(stri,pos('=',stri)+2,length(stri)-pos('=',stri)-2)));
           case Symb of
            Range : Rang:=Value;
            Background: Back:=Value;
            Width : line_length:=Value;
            Height : line_count:=Value;
           end;
         end;
       end;
     end;
    close(inh);
    assign(inp,paramstr(1));
    FileMode:=0;  {files will be opened as read-only}
    if compressed then
     begin
      reset(inp,1);
      seek(inp,$800);
     end
    else
     begin
      reset(inp,2);
      seek(inp,$400);
     end;
    line_length_byte:=2*line_length;
   end
  else
   ST_Open:=false;
 end;

procedure ST_sof;
 begin
     if compressed then
      seek(inp,$800)
     else
      seek(inp,$400);
 end;

procedure ST_line;
var
 bufcw: FtImLine2Type;
 bufcb: FtImLine1Type absolute bufcw{FtImLine2};
 bufcs: array[1..2048] of shortint absolute bufcw{FtImLine2};
 c_line,ww: word;
 NumRead: integer;
begin
 {if FitsKind then
  begin
   if FtReadIm(h,FtImLine1) then
    for w:=1 to Line_length do bufw[w]:=swap(bufw[w]);
  end
 else
  }
    if compressed then
     begin
      BlockRead(inp,c_line,2,NumRead);
      if c_line=line_length_byte then
       BlockRead(inp,bufw,c_line,NumRead)
      else
       begin
        BlockRead(inp,bufcb,c_line,NumRead);
        ww:=1;
        bufw[ww]:=bufcw[ww];
        w:=2;
        while w<c_line do
         begin
          inc(w);inc(ww);
          if bufcb[w]<>128 then
           bufw[ww]:=bufw[ww-1]+bufcs[w]
          else
           begin
            inc(w);
            bufw[ww]:=bufcb[w];
            inc(w);
            bufw[ww]:=bufw[ww]+ bufcb[w] shl 8
           end
         end;
       end
     end
    else
     BlockRead(inp,bufw,line_length,NumRead);
end;

procedure ST_Close; {closes the file}
begin
 close(inp);
end;

end.
