 {~ *.FITS to *.dbf conversion, for ASCII tables FITS files ~}

Program FITS_to_dbf; {by Jan Hollan}
(*  Copyright (C) 1999 Jan Hollan

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)

uses dos,
     ftbridge, dbbridge, angles_o, str_num;
var
 i:longint;
 j,j1:word;
 FileName:PathStr;   FDir:   DirStr; FName:   NameStr; FExt:   ExtStr;
 FileNameDb:PathStr; FDirDb: DirStr; FNameDb: NameStr; FExtDb: ExtStr;
 TableNo:byte;
 TableNoStr:string[2];
 Old_perc:integer;
 orig_name:string[10];
 l_o_n:byte;
 n_add:char;
const AllChar:boolean=false;

 procedure help;
  begin
   writeln(
'fit2dbf <name of FITS file> [<name of dBase file> [<name of inf-file>]]'+cl2+
' will make from'+cl+
'    *.fit  two files:'+cl+
' a  *.dbf  one with data, and'+cl+
' a  *.inf  one with FITS-file headers as a text file',cl2,
'(if <name of dBase file> begins with - sign',cl,
' then all fields will be of Character type:',cl,
' this is meant for preventing a change of righthand voids to zeroes)',cl2,

'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'
);
   halt;
  end;

begin
if paramcount<1 then help;
if pos('?',paramstr(1))>0 then help;
FSplit(paramstr(1),FDir,FName,FExt);
if paramcount<3 then
 begin
  if paramcount=2 then
   begin
    FileName:=ParamStr(2);
    if FileName[1]='-' then
     begin
      AllChar:=true;
      FileName:=copy(FileName,2,length(FileName)-1);
     end;
    FileNameDb:=FileName;
    FSplit(FileNameDb,FDirDb,FNameDb,FExtDb);
    if FExtDb='' then FExtDb:='.dbf';
    if FNameDb='' then FNameDb:=FName;
    FileNameDb:=FDirDb+FNameDb+FExtDb;
    FName:=FNAmeDb;
    FDir:=FDirDb;
    FExt:='.inf';
    FileName:=FDir+FName+FExt;
   end
  else
   begin
    FExt:='.inf';
    FileName:=FDir+FName+FExt;
    FNameDb:=FName;
    FDirDb:=FDir;
    FExtDb:='.dbf';
    FileNameDb:=FDirDb+FNameDb+FExtDb;
   end
 end
else
 begin
  FileName:=paramstr(3);
  FSplit(FileName,FDir,FName,FExt);
  FileNameDb:=paramstr(2);
  FSplit(FileNameDb,FDirDb,FNameDb,FExtDb);
 end;

TableNo:=1;
repeat
 writeln('Converting table No.', TableNo:2);
 Old_Perc:=-1;
 if TableNo>1 then
  begin
   if TableNo<10 then
    TableNoStr:=SI(1,TableNo)
   else
    TableNoStr:=SI(2,TableNo);
   if Length(FName) < 8-(TableNo div 10) then
    FileName:=FDir+FName+TableNoStr+FExt
   else
    FileName:=FDir+copy(FName,1,7-(TableNo div 10))+TableNoStr+FExt;
  end;
 if not rt_rewrite(FtDocFile,FileName) then halt;
 FTNoWriteHeading:=false;
 if not ftinitsearch('',paramstr(1),TableNo) then
  begin
   Close(FtDocFile);
   erase(FtDocFile);
   halt;
  end;
 Close(FtDocFile);
 for j:=2 to FtNuField do     {preventing identical field names}
  begin
   i:=1;
   orig_name:=FtInfo[j].field;
   l_o_n:=length(orig_name);
   for j1:=1 to j-1 do
    if FtInfo[j1].field=FtInfo[j].field then
     begin
      inc(i);
      if i<10 then n_add:=chr(48+i)
      else n_add:=chr(55+i);
      case l_o_n of
       1..8 : FtInfo[j].field:=orig_name+'_'+n_add;
          9 : FtInfo[j].field:=orig_name+n_add;
         10 : FtInfo[j].field:=copy(orig_name,1,9)+n_add;
      end;
     end;
  end;
 if AllChar then
  for j:=1 to FtNuField do
   DbNewField(FtInfo[j].field,
             'C',
             FtInfo[j].len,
             FtInfo[j].dec)
 else
  for j:=1 to FtNuField do
   DbNewField(FtInfo[j].field,
             FtInfo[j].Typ,
             FtInfo[j].len,
             FtInfo[j].dec);
 if TableNo>1 then
  if Length(FNameDb) < 8-(TableNo div 10) then
   FileNameDb:=FDirDb+FNameDb+TableNoStr+FExtDb
  else
   FileNameDb:=FDirDb+copy(FNameDb,1,7-(TableNo div 10))+TableNoStr+FExtDb;
 if DbCreate(FileNameDb) then
  begin
   for i:=1 to FtNuRec do
    begin
     if FtRead(i,rec) then
      if not DbWrite(0,rec) then
       begin
        writeln('Failed when writing record:',i);
        FtClose;
        DbClose;
        halt;
       end
      else
       if (i*100) div FtNuRec > old_Perc then
        begin
         inc(old_perc);
         write(#13,old_perc:3,'% finished');
        end;
    end;
   DbClose;
  end;
 FtClose;
 writeln;
 inc(TableNo);
until false;
end.

