 {~ Sets the date (or even time) of a file (files), e-mail or general ones ~}

program give_file_date;
 {for e-mails and any files , by Jan Hollan}

uses Dos,        {Borland TP unit}
     un_str_m,solar_ut,angles_o,str_num,params;   {J.H.'s units}
const
cl=#13#10;
h1=cl+
'GFDate <name of file> [{/Ddd.[mm.[yy]]] } / { /F<Name of date-source file> }]'+cl+
' will set the file date'+cl+
' according to the following parameter (missing part is assumed to be current).'+cl;
h2=
'If just the first parameter is given and there is a  >Date:< line'+cl+
' in that file, the date and time are set according to that line'+cl+
' (if possible, time is adapted to actually valid central European timing).'+cl;

h3=cl+
'There can be more file names on the line. Each /D or /F switch influences'+cl+
'the immediately preceding file and the following ones.'+cl;
h4=cl+
'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'+cl;


var
  f,f2: text;
  i,our_t_ut:byte;
  hs,yy2,mm2,dd2,dd:word;
  datum,Par:string;
  head:string[5];
  DoWt:string[4];
  c:char;
  month_t:string[3];
  time_t:string[8];
  t_utT:string[5];
  t_ut,Auxreal:real;
  wrong_cod:integer;
  ftime : Longint; { For Get/SetFTime}
  dt : DateTime; { For Pack/UnpackTime}
  line:string;
const
 EMon: array [1..12] of string[3]=('Jan','Feb','Mar','Apr','May','Jun',
                                    'Jul','Aug','Sep','Oct','Nov','Dec');
 Chosen_time:boolean=false;
 File_opened:boolean=false;

 procedure help(s:string);
  begin
   if s<>'' then writeln(s,cl);
   write(h1,h2,h3,h4);
   halt
  end;

 procedure process_file;
  var j:byte;
  begin
   if not Chosen_time then
    begin
     repeat
      read(f,head);
      if head='Date:' then
        {readln(f,DoWt,dt.day,c,month_t,dt.year,time_t,t_utT)}
       begin
        readln(f,line);
        DoWt:=  copy(ItemStr(1,line),1,3);
        dt.day:= I_S(ItemStr(2,line));
        month_t:=    ItemStr(3,line);
        dt.year:=I_S(ItemStr(4,line));
        time_t:=     ItemStr(5,line);
        if ItemCount(line)>5 then
         t_utT:=     ItemStr(6,line);
       end
      else
       readln(f);
     until (head='Date:')  or  eof(f);
     if not eof(f) then
      begin
       with dt do
        begin
         if year<1800 then inc(year,1900);
         for j:=1 to 12 do
          if Month_t=EMon[j] then month:=j;
         if not __2timestr(time_t,hour,min,sec,hs) then
          begin hour:=0; min:=0; sec:=0 end;
         val(t_utT,t_ut,wrong_cod);
         if wrong_cod=0 then
          begin
           t_ut:=t_ut / 100;
           if month in [4..10] then our_t_ut:=2 else our_t_ut:=1;
           JD:=JD0(year,month,day)+(hour+our_t_ut-t_ut)/24;
           time_t:=DoW(JD,0,0);
           year:=yyyy; month:=mm; day:=nd;
           hour:=round(frac(jd)*24);
           if hour<12 then inc(hour,12) else dec(hour,12);
          end
        end;
       PackTime(dt,ftime);
       Reset(f); { Reopen file for reading }
         { (Otherwise close will update time) }
       SetFTime(f,ftime);
      end;
    end
   else
    SetFTime(f,ftime);
   Close(f);
  end;

begin
if paramcount<1 then help('');
for i:=1 to paramcount do
 begin
  par:=paramstr(i);
  if pos('?',Par)>0 then help('');
  if par[1] in ['-','/'] then
   case UpCase(Par[2]) of
    'F':
      begin
       Par:=copy(Par,3,length(Par)-2);
       if not rt_reset('',f2,Par) then help('The date-giving file not found!');
       GetFTime(f2,ftime);
       Chosen_Time:=true;
      end;
    'D':
      begin
       Par:=copy(Par,2,length(Par)-1);
       if not Par_Date then halt;
       with dt do
        begin
         hour:=0; min:=0; sec:=0;
         year:=yyyy; month:=mm; day:=dd;
        end;
       PackTime(dt,ftime);
       chosen_time:=true;
      end
   end
  else
   begin
    if File_opened then
     process_file;
    if not rt_Reset('',f,par) then help('Sorry, no file '+Par+'is here.'+cl)
    else File_opened:=true;
   end;
 end;
if File_opened then
 process_file;

end.
