 {~ Julian date, or two dates and a time interval between them ~}

program Interval;   {by Jan Hollan}
(*  Copyright (C) 1999 Jan Hollan

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)
uses dos,{graph, is not needed, of course...} 
             {standard Borland Turbo Pascal ones}
     un_str_m, params, solar_ut;  {by Jan Hollan}
const cl=#13#10;
h1 = cl+
'interval [D]dd.[mm.[yy]]] [Thh[.mm[.ss] [UT#] [M]'+cl+
'        [[D]dd.[mm.[yy]]] [Thh[.mm[.ss]] [UT#]'+cl;
h2 = cl+
'Program gives the Julian date of the given moment,'+cl+
' or two dates and a time difference between them.'+cl+
cl+
' Missing parts of date and time are taken from system date and time'+cl;
h3=
' M asks for a Modified Julian Date (MJD=JD-2 400 000.5)'+cl+
' UT is time difference of the used time and UTC'+cl+
'  (default 1 h Nov.-Mar., then 2 h)'+cl;
h4=
' F{G|J} forces Gregorian (Julian) dating even outside the standard interval'+cl;
h5=                                                       cl+
'( (C) Jan Hollan, N.Copernicus Observatory and Planetarium in Brno, 1999;'+cl+
' subject to the GNU General Public License, http://www.gnu.org/copyleft;'+cl+
' source code available at http://astro.sci.muni.cz/pub/hollan/programmes)'+cl;

modijd:boolean=false;
FirstDateGiven:boolean=false;
SecondDateGiven:boolean=false;

var jd1,jd2:real; jfor:byte;

procedure help;
begin
 write(h1,h2,h3,h4,h5);
 halt;
end;

procedure Process_date;
 begin
  if FirstDateGiven then
   begin
    Get_JD;
    JD1:=jd;
    if not Par_Date then help;
    SecondDateGiven:=true;
   end
  else
   begin
    if not Par_Date then help;
    FirstDateGiven:=true;
   end;
 end;

begin
 if paramcount > 0 then  for jfor:=1 to paramcount do
   begin
    Par:=paramstr(jfor);
    if (Par[1]='/') or (Par[1]='-') then Par:=copy(Par,2,length(par)-1);
    Par:=__cvtstr(Par,_To_UpCase_Str);
    case Par[1] of
     '?': Help;
     'F': if length(par)>1 then
           case Par[2] of
             'J': ForcedJulian:=true;
             'G': ForcedGregorian:=true;
           end;
     'M': ModiJD:=true;
     'T': if not Par_Time then help;
     'U': if not Par_UT then help;
     'D': Process_date;
    else
     begin
      Par:='D'+Par;
      Process_date;
     end;
    end; {of case}
   end; {of for}
 if not SecondDateGiven then
  begin
   Get_JD;
   JD1:=jd;
  end;
 if ModiJD then jd1:=jd1-jd_mjd;
 if not ModiJD then
  write('    JD')
 else
  write('   MJD');
 if SecondDateGiven then
  begin
   Get_JD;
   jd2:=jd;
   if not ModiJD then
    write('_1         JD_2     difference / 1 day')
   else
    write('_1        MJD_2     difference / 1 day');
   if jd2-jd1 > 365.2422 then
    write('  (/ 1 year)');
  end;
 write(cl,jd1:11:3);
 if SecondDateGiven then
  begin
   if ModiJD then jd2:=jd2-jd_mjd;
   write(jd2:13:3,jd2-jd1:15:3);
   if jd2-jd1 > 365.2422 then
    write((jd2-jd1)/365.2422:15:3)
  end;
 writeln;
end.
